<?php

namespace MetodikaTI\Http\Controllers\Back\Dashboard;

use Illuminate\Database\Eloquent\Collection;
use Illuminate\Http\Request;
use MetodikaTI\AppUser;
use MetodikaTI\User;
use MetodikaTI\Http\Controllers\Controller;
use MetodikaTI\Order;
use MetodikaTI\Codigos;
use MetodikaTI\UsersApp;
use MetodikaTI\Incidentes;
use MetodikaTI\Comunicados;
use MetodikaTI\Institution;

use Auth;

class DashboardController extends Controller
{

    public function index()
    {

        $app_users = "";
        $orders_terminado = "";
        $orders_pendientes = "";
        $users_app = [];
        $incidentes = [];
        $comunicados = [];
        $ultimos_incidentes = [];
        $codigosUsers = [];
        $categorias = [];
        $num_instituciones = 0;
        $users_inst_num = 0;
        $users_inst = [];
        $ult_instituciones = [];
        $users_num = 0;
        $logo_insititucion = null;        

        $user = Auth::user();
        // $tipo_dashboard= 2;

        // error_log($user->user_profile_id);

        if( $user->user_profile_id === 2 ){

            $tipo_dashboard = 1;

            $num_instituciones = Institution::get()->count();
            $ult_instituciones = Institution::orderBy('id', 'DESC')->limit(5)->get();

            $users_inst_num = User::where("user_profile_id", 3)->count();
            $users_inst     = User::where("user_profile_id", 3)->orderBy('id', 'DESC')->limit(5)->get();

            $users_num = User::count();
            

        }else if( $user->user_profile_id === 3 ){ 
            
            $tipo_dashboard= 2;

            $codigos = Codigos::where("id_institucion", $user->id_institucion)->pluck("id")->toArray();        
            $users_app = UsersApp::whereIn( "id_codigo", $codigos )->count();
    
            $incidentes = Incidentes::where("id_institucion", $user->id_institucion)->count();
            $comunicados = Comunicados::where("id_institucion", $user->id_institucion)->count();
    
            $ultimos_incidentes = Incidentes::where("id_institucion", $user->id_institucion)->orderBy('id', 'DESC')->limit(5)->get();
    
                    
            $codigos = Codigos::where("id_institucion",$user->id_institucion)->orderBy('id', 'DESC')->limit(5)->get(); 
    
            $codigosUsers = array();
    
            foreach ($codigos as $key => $codigo) {
                
                $users_app = UsersApp::where("id_codigo", $codigo->id)->count();                        
                array_push( $codigosUsers, array( "id"       => $codigo->id, 
                                                  "codigo"   => $codigo->codigo, 
                                                  "name"     => $codigo->name, 
                                                  "usuarios" => $users_app,
                                                  "creado"     => $codigo->created_at, ) 
                                                );
            }  
            
            $categorias = array( array("num" => 1, "name" => "Bullying"), array("num" => 2, "name" => "Ciberbullying"),
                                 array("num" => 3, "name" => "Violencia"), array("num" => 4, "name" => "Vandalismo"),
                                 array("num" => 5, "name" => "Actos inapropiados"), array("num" => 6, "name" => "Abuso de poder"),
                                 array("num" => 7, "name" => "Acoso / Abuso sexual"), array("num" => 8, "name" => "Exclusión"),
                                 array("num" => 9, "name" => "Distribución de material no autorizado"), array("num" => 10, "name" => "Robo") 
                                );

        }else{
            //bienvenida
            $tipo_dashboard = 3;
            
            $logo_insititucion = Institution::find($user->id_institucion);
            

        }


        return view("back.dashboard.dashboard", [ "app_users" => $users_app, 
                                                  "incidentes" => $incidentes, 
                                                  "comunicados" => $comunicados,
                                                  "ultimos_incidentes" => $ultimos_incidentes, 
                                                  "codigos_users" => $codigosUsers, 
                                                  "categorias" => $categorias,
                                                  "tipo_dashboard" => $tipo_dashboard,
                                                  "num_instituciones" => $num_instituciones,
                                                  "ult_instituciones" => $ult_instituciones,
                                                  "users_inst_num" => $users_inst_num,
                                                  "users_inst" => $users_inst,
                                                  "users_num" => $users_num,
                                                  "logo_insititucion" => $logo_insititucion  
                                                ]);

    }

}
