<?php

namespace MetodikaTI\Http\Controllers\Back\Dashboard;

use Illuminate\Http\Request;
use MetodikaTI\Http\Controllers\Controller;
use MetodikaTI\Incidentes;
use MetodikaTI\Institution;
use MetodikaTI\Codigos;
use MetodikaTI\Chats;
use MetodikaTI\User;
use MetodikaTI\Notas;
use MetodikaTI\UsersApp;
use MetodikaTI\Library\URI;
use MetodikaTI\Categorias;
use MetodikaTI\Library\Pastora;
// use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Mail;
use MetodikaTI\NotificacionesUsuario;
use MetodikaTI\IncidentesResponsables;

use Auth;


class IncidentesController extends Controller
{
    public function index(){

        // $categorias = array( array("num" => 1, "name" => "Bullying"), array("num" => 2, "name" => "Ciberbullying"),
        //                      array("num" => 3, "name" => "Violencia"), array("num" => 4, "name" => "Vandalismo"),
        //                      array("num" => 5, "name" => "Actos inapropiados"), array("num" => 6, "name" => "Abuso de poder"),
        //                      array("num" => 7, "name" => "Acoso / Abuso sexual"), array("num" => 8, "name" => "Exclusión"),
        //                      array("num" => 9, "name" => "Distribución de material no autorizado"), array("num" => 10, "name" => "Robo") 
        //                     );
        
        $categorias = Categorias::all();           
        // $severidad = array( array( "num" => 1, "name" => "Baja" ), array("num" => 2, "name" => "Media" ), array("num" => 3, "name" => "Alta" ) );

        $user = Auth::user();
        $incidentes_user = array();
        $incidentes =  Incidentes::where( "id_institucion", $user->id_institucion )->get();

        // $incidente = Incidentes::select('*')->join("users", "incidentes.asignado","=","users.id")                                            
        //                                     ->orWhere( "incidentes.asignado",0 )
        //                                     ->where( "incidentes.id_institucion", $user->id_institucion )                                                                                        
        //                                     ->get();
        
        foreach ($incidentes as $value) {

            if( $value->asignado == 0 ){
                array_push($incidentes_user, array( "id" => $value->id, "asignado" => "Pendiente", "name" => "Pendiente",
                                                    "mensaje" => $value->mensaje, "created_at" => $value->created_at,
                                                    "codigo" => $value->codigo, "multimedia" => $value->multimedia,
                                                    "estatus" => $value->estatus, "categoria" => $value->categoria,
                                                    "severidad" => $value->severidad, "calificacion" => $value->calificacion,
                                                    "updated_at" => $value->updated_at, "lastname" => ""
                                                ));
            }else{

                $user = User::find( $value->asignado );
                array_push($incidentes_user, array( "id" => $value->id, "asignado" => "Asignado", 
                                                    "mensaje" => $value->mensaje, "name" => $user->name,
                                                    "lastname" => $user->lastname, "created_at" => $value->created_at,
                                                    "codigo" => $value->codigo, "multimedia" => $value->multimedia,
                                                    "estatus" => $value->estatus, "categoria" => $value->categoria,
                                                    "severidad" => $value->severidad, "calificacion" => $value->calificacion,
                                                    "updated_at" => $value->updated_at
                                                 ));                                                 
            }
        }

        // $todos_incidentes = array_merge( $incidentes, $incidente );

        error_log( print_r($incidentes_user, true) );

        // $incidente = DB::table('incidentes')->join("users", "incidentes.responsable","=","users.id")
        //                                     ->orWhere("incidentes.responsable","=",0)                                            
        //                                     ->where( "incidentes.id_institucion", $user->id_institucion )
        //                                     ->get();
        // $incidente = Incidentes::select('*')->join("users", "incidentes.responsable","=","users.id")                                            
        //                                     ->where( "incidentes.id_institucion", $user->id_institucion )
        //                                     ->joinleft()
        //                                     // ->orWhere("incidentes.responsable","=",0)
        //                                     ->get();
              
    
        return view('back.incidentes.index', array( "incidentes" => $incidentes_user, "categorias" => $categorias, 'permitions' => URI::checkPermitions() ));

    }

    public function ver_insidente( $id ){        

        // $categorias = array( array("num" => 1, "name" => "Bullying"), array("num" => 2, "name" => "Ciberbullying"),
        //                      array("num" => 3, "name" => "Violencia"), array("num" => 4, "name" => "Vandalismo"),
        //                      array("num" => 5, "name" => "Actos inapropiados"), array("num" => 6, "name" => "Abuso de poder"),
        //                      array("num" => 7, "name" => "Acoso / Abuso sexual"), array("num" => 8, "name" => "Exclusión"),
        //                      array("num" => 9, "name" => "Distribución de material no autorizado"), array("num" => 10, "name" => "Robo") 
        //                     );

        $categorias = Categorias::all(); 
        $incidentes_resp = IncidentesResponsables::where( "id_incidente", base64_decode($id) )->get();          

        $estatus = array( array( "num" => 1, "name" => "Abierto" ), array("num" => 2,"name" => "Seguimiento" ), array("num" => 3, "name" => "Cerrado" ) );

        $severidad = array( array( "num" => 1, "name" => "Baja" ), array("num" => 2, "name" => "Media" ), array("num" => 3, "name" => "Alta" ) );

        $user      = Auth::user();
        
        $incidente = Incidentes::find( base64_decode( $id ) );

        if( !$incidente ){
            // return view('back.incidentes.view');
            abort(404);
        }

        $codigo    = Codigos::where( "id", $incidente->id_codigo )->first();
        $users     = User::where("id_institucion", $user->id_institucion)->get();        
        
        $usuario_reporto = UsersApp::select("id","status")->find( $incidente->id_user );
                        
        return view('back.incidentes.view', array( "responsables" => $incidentes_resp, "usuario_reporto" => $usuario_reporto, "usuario" => $user, "user" => $user,"incidente" => $incidente, "categorias" => $categorias, "estatus" => $estatus, "severidad" => $severidad, "codigo" => $codigo, "users" => $users, 'permitions' => URI::checkPermitions() ));

    }

    public function update_incidente( Request $request, $id ){
        

        $response["status"] = false;        

        $this->validate(
            $request, 
            [   
                'estatus'   => 'required', 
                'categoria' => 'required',
                'severidad' => 'required',
                'asignado'  => 'required'                                          
            ],
            [   
                'estatus.required'   => 'El estatus es requerido',
                'categoria.required' => 'La categoria es requerida',
                'severidad.required' => 'La severidad es requerida',
                'asignado.required' => 'Es necesario asignar algún responsable',                                
            ]
        );

        $incidente = Incidentes::find(base64_decode($id));

        $incidente->estatus       = $request->estatus;
        $incidente->categoria     = $request->categoria;
        $incidente->severidad     = $request->severidad;
        // $incidente->asignado      = $request->asignado;
        $incidente->accion_tomada = $request->accion_tomada;
                

        if( $incidente->save() ){

            // error_log( print_r( $request->asignado, true ) );
            

            $user = Auth::user();
            // $user_asignado = User::find($request->asignado);
            // echo $user_asignado;
            // $email_envair = $user_asignado->email;
            // return;

            IncidentesResponsables::where("id_incidente", $incidente->id)->delete();

            $url = url("/assets/images/calificacion/10-s.png");  

            foreach ($request->asignado as $key => $asignado) {
                error_log( $asignado );
                $inc_resp = new IncidentesResponsables();
                $inc_resp->id_user = $asignado;
                $inc_resp->id_incidente = $incidente->id;
                $inc_resp->save();

                if( $user->id !== $asignado ){

                                                                             
                    $user_asignado = User::find($asignado);
                    $institucion = Institution::find( $user_asignado->id_institucion );
                
                    $notas = new Notas();                
                    $notas->id_incidente = $incidente->id;
                    $notas->id_user      = $user->id;
                    $notas->mensaje      = "El usuario ". $user->name." asignó este incidente a ".$user_asignado->name;
                    $notas->save();                                    
                    
                    $chat = false;

                    try {
                        \Mail::send("mail.incidente_asignado", ["url" => $url, "nombre_institucion" => $institucion->name, "id_reporte" => $incidente->id, "chat" => $chat ], function ($message) use ($user_asignado) {
                            $message->to($user_asignado->email)->subject('Reporte');
                        });
                    } catch (Exception $e) {
                        echo 'Excepción capturada: ',  $e->getMessage(), "\n";
                    }

                }
            }

            // if( $user->id !== $user_asignado->id ){
                
            //     $institucion = Institution::find( $user_asignado->id_institucion );
            //     $url = url("/assets/images/calificacion/10-s.png");                                                           
            //     $user_asignado = User::find($request->asignado);
             
            //     $notas = new Notas();                

            //     $notas->id_incidente = base64_decode($id);
            //     $notas->id_user      = $user->id;
            //     $notas->mensaje      = "El usuario ". $user->name." asignó este incidente a ".$user_asignado->name;
            //     $notas->save();

            //     try {
            //         \Mail::send("mail.incidente_asignado", ["url" => $url, "nombre_institucion" => $institucion->name, "id_reporte" => $id ], function ($message) use ($user_asignado) {
            //             $message->to($user_asignado->email)->subject('Reporte');
            //         });
            //     } catch (Exception $e) {
            //         echo 'Excepción capturada: ',  $e->getMessage(), "\n";
            //     }
                
            // }

            $response["status"] = true;                
            $response["url"] = $id;//route("incidentes");          
            $response["message"] = "Los datos se actualizaron correctamente.";
        }else{
            $response["message"] = "¡Uy! Algo salió mal. No se pudo actualizar el incidente.";
        }       

        return response()->json($response, 200);

    }

    public function ver_insidentes( $tipo ){

        $tipo_num = 0;

        if( $tipo == "nuevos" ){
            $tipo_num = 0;
        }

        if( $tipo == "abiertos" ){
            $tipo_num = 1;
        }        

        if( $tipo == "seguimiento" ){
            $tipo_num = 2;
        }

        if( $tipo == "cerrados" ){
            $tipo_num = 3;
        }


        $user       = Auth::user();
        $incidentes = Incidentes::where( "id_institucion", $user->id_institucion )->where("estatus",$tipo_num)->get();
        return view('back.incidentes.view_tipo', array( "incidentes" => $incidentes, 'permitions' => URI::checkPermitions() ));
    }

    public function chat( Request $request ){

        // $response["status"] = false;

        $this->validate(
            $request, 
            [   
                'id_incidente' => 'required', 
                // 'id_user'      => 'required',                                            
            ]
        );

        //->where( "id_user", $request->id_user )
    
        $chat      = Chats::where( "id_incidente", $request->id_incidente )->orderBy('id','ASC')->get();                 
        $incidente = Incidentes::find( $request->id_incidente ); 
        
        $users     = User::select("name","lastname","id")->where("id_institucion", $incidente->id_institucion)->get();
        // $chats = Chats::select('*')
        //                     ->join('users', 'chats.id_user', '=', 'users.id')
        //                     ->get();
        
        $response["chat"]  = $chat;
        $response["users"] = $users;
        // $response["chats"] = $chats;

        return response()->json($response, 200);

    }

    public function chat_refresh( Request $request ){

        $this->validate(
            $request, 
            [   
                'id_incidente' => 'required',                 
                'user_type'    => 'required'                                            
            ]
        );

        $chat = Chats::where( "id_incidente", $request->id_incidente )->where("user_type", $request->user_type)->where( "estatus", 0 )->orderBy('id','DESC')->get();        

        $response["chat"] = $chat;

        return response()->json($response, 200);

    }

    public function registro_chat( Request $request ){
        
        $response = array();
        $response["status"] = false;

        $this->validate(
            $request, 
            [   
                'id_incidente' => 'required', 
                'id_user'      => 'required', 
                'mensaje'      => 'required|max:255', 
            ]
        );


        $chat_verify = Chats::where("id_incidente", $request->id_incidente)->where("user_type", 1)->first();
        
        if( $chat_verify ){
            $user_app = UsersApp::find($chat_verify->id_user);
            // error_log( empty($user_app) );
            if( empty($user_app) ){
                $response["mensaje"] = "El usuario ha cambiado de código o cerró su sesión.";
                return response()->json($response, 200);
            }
        }

        $chat = new Chats();
        $user = Auth::user();

        $chat->id_incidente = $request->id_incidente;
        $chat->id_user      = $user->id;//$request->id_user;
        $chat->user_type    = $request->user_type; // es mensaje de admin
        $chat->mensaje      = $request->mensaje;

        if( $chat->save() ){

            //NOTIFICACION PUSH            
            $incidente = Incidentes::find($request->id_incidente);
            $notificaciones = NotificacionesUsuario::where("id_user", $incidente->id_user)->first();

            if( $notificaciones ){

                if( $notificaciones->token ){

                    $response["RESPONSE"]["UUID"] = $notificaciones->token; 
                    $response["RESPONSE"]["TEXTO_NOTIFICACION"] = "Tienes un mensaje nuevo";
                    $response["RESPONSE"]["TITLE"] = "Notificación";
                    $response["RESPONSE"]["DATA"] = array( "tipo" => "chat", "id_incidente" => $request->id_incidente );                                        

                    Pastora::sendPushNotification( $response );

                }

            }
            

            $response["mensaje"] = "El mensaje se registró correctamente";
            $response["status"] = true;

        }else{
            
            $response["mensaje"] = "¡Uy! Algo salió mal. No se pudo registrar el mensaje.";

        }
        

        return response()->json($response, 200);
    }

    public function mensaje_visto( Request $request ){

        $response["status"] = false;

        //es para identificar que ya fue visto
        $this->validate(
            $request, 
            [   
                'ids'          => 'required',
                'id_incidente' => 'required',                                                         
            ]
        );

        $chats =  Chats::where("id_incidente", $request->id_incidente)->whereIn('id',$request->ids)->update([ "estatus" => 1]);

        if( $chats ){
            $response["status"]  = true;
            $response["mensaje"] = "Los mensajes se actualizaron correctamente";
        }else{
            $response["mensaje"] = "¡Uy! Algo salió mal. No se pudieron actualizar los chats.";
        }

        return response()->json($response, 200);

    }

    public function delete_incidente( $id ){

        if( $id ){
            $incidente = Incidentes::where("id", base64_decode( $id ) )->delete();

            if( $incidente ){
                
                Chats::where("id_incidente", base64_decode( $id ))->delete();
                Notas::where("id_incidente", base64_decode( $id ))->delete();

                $folderPath = url("/assets/movil/"). md5(base64_decode( $id ));

                if (file_exists($folderPath)) {
                    unlink( $folderPath );                
                }

                $response["status"] = true;
                $response["url"] = route('incidentes');
                $response["message"] = "El incidente se elimino correctamente";
            }else{
                $response["status"] = false;
                $response["message"] = "¡Uy! Algo salió mal. No se encontró el incidente.";
            }


        }else{
            $response["message"] = "¡Uy! Algo salió mal. No se pudo eliminar el incidente.";
        }

        return response()->json($response, 200);

    }

    public function registro_nota( Request $request ){

        $this->validate(
            $request, 
            [                   
                'id_incidente' => 'required',
                'id_user' => 'required',
                'mensaje' => 'required',                                                        
            ]
        );

        $notas = new Notas();
        $user = Auth::user();        

        $notas->id_incidente = $request->id_incidente;
        $notas->id_user      = $user->id;
        $notas->mensaje      = $request->mensaje;

        if( $notas->save() ){
            $response["nota"] = $notas;
            error_log($notas);
            $response["status"] = true;            
        }else{
            $response["message"] = "¡Uy! Algo salió mal. No se pudo eliminar la nota.";
        }
        
        return response()->json($response, 200);
    }

    public function get_notas( Request $request ){
        // $response["status"] = false;

        $this->validate(
            $request, 
            [                   
                'id_incidente' => 'required',                                                         
            ]
        );

        $notas_inner = Notas::select('notas.id','notas.mensaje', 'users.name', 'users.lastname', 'notas.created_at', 'notas.updated_at')
                            ->join('users', 'notas.id_user', '=', 'users.id')
                            ->where("notas.id_incidente", $request->id_incidente)
                            ->get();

        // error_log( print_r( $notas_inner, true ) );

        // $notas = Notas::where( "id_incidente", $request->id_incidente)->get();
        $response["notas"] = $notas_inner;

        return response()->json($response, 200);
    }

    public function update_user_app( Request $request ){

        $response["status"] = false;

        $this->validate(
            $request, 
            [   
                'id' => 'required',
                'status' => 'required',                                                             
            ]     
        );

        $status = 0;
        if( $request->status  ){
            $status = 1;
        }

        $update = UsersApp::where("id",$request->id)->update([ "status"=> $request->status ]);

        if( $update ){
            $response["status"] = true;
            error_log( $request->status );
            if( $request->status == 1 ){
                $response["message"] = "El usuario se encuentra activo.";
            }else{ 
                $response["message"] = "El usuario se encuentra inactivo.";
            }
            
        }else{
            $response["status"] = false;
            $response["message"] = "¡Uy! Algo salió mal. No se pudo actualizar el usuario.";

        }

        return response()->json($response, 200);

    }


    public function responder_incidente( Request $request, $id ){

    }
}
