<?php

namespace MetodikaTI\Console\Commands;

use Illuminate\Console\Command;
use Illuminate\Support\Facades\Storage;
use MetodikaTI\Incidentes;
use MetodikaTI\Chats;
use Carbon\Carbon;
use MetodikaTI\IncidentesResponsables;
use MetodikaTI\User;
use Illuminate\Support\Facades\Mail;

class RecordatorioChat extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'recordatorio:chat';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Verifica que chat no ha sido contestado';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
       
        $incidentes = Incidentes::all();

        foreach ($incidentes as $key => $incidente) {
            $chat = Chats::where("id_incidente", $incidente->id)->orderBy('created_at', 'DESC')->take(1)->get();
            // error_log( json_encode($chat) );
            if( count($chat) > 0 ){

                if( $chat[0]->user_type == 1 ){
                    $datework = new Carbon($chat[0]->recordatorio_chat);
                    $diff = Carbon::parse($datework)->diffInHours(); // diferencia por horas
                    if( $diff >= 24 ){
                        
                        $incidentes_resp = IncidentesResponsables::where( "id_incidente", $incidente->id )->get();

                        foreach ($incidentes_resp as $key => $resp) {
                            $user = User::find( $resp->id_user );
                            
                            if( $user ){
                                //mandamos correo
                                error_log( $user );
                                try {
                                    \Mail::send("mail.incidente_asignado", ["url" => $url, "nombre_institucion" => $institucion->name, "id_reporte" => $incidente->id, "chat" => $chat ], function ($message) use ($user_asignado) {
                                        $message->to($user_asignado->email)->subject('Reporte');
                                        // $message->to("pizanho18@gmail.com")->subject('Reporte');
                                    });
                                } catch (Exception $e) {
                                    echo 'Excepción capturada: ',  $e->getMessage(), "\n";
                                }

                            }

                        }
                        // error_log( print_r($incidentes_resp, true). " ==== ". $incidente );
                    }

                }

            }
            // error_log( "ID incidente =>".$value->id. json_encode($chat,true) );
        }
        // $chats      = Chats::whereIn("id_incidente", $incidentes)->orderBy('created_at', 'DESC')->take(1)->get();
        
    }
}
