<?php

namespace MetodikaTI\Http\Controllers\API;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use MetodikaTI\Http\Controllers\Controller;
use MetodikaTI\UsersApp;
use MetodikaTI\User;
use MetodikaTI\Codigos;
use MetodikaTI\Institution;
use MetodikaTI\Telefonos;
use MetodikaTI\Incidentes;
use MetodikaTI\Chats;
use MetodikaTI\Horarios;
use MetodikaTI\Preguntas;
use Carbon\Carbon;
use MetodikaTI\AppUserTokenSession;
use MetodikaTI\Comunicados;
use MetodikaTI\Vacaciones;
use PDepend\Util\Log;
use MetodikaTI\ComunicadosCodigos;
use MetodikaTI\NotificacionesUsuario;
use MetodikaTI\ComunicadosVistas;
use MetodikaTI\IncidentesResponsables;
use MetodikaTI\Library\Pastora;

use Auth;

class APIController extends Controller
{
    public function do_login(Request $request)
    {

        $response = array();
        $response["mensaje"] = "";
        $response["estatus"] = 0;
        // $response["isInactive"] = false;

        $validator = \Validator::make($request->all(),
            [
                'device_id' => 'required',
                'codigo' => 'required',
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }

        // if( empty($request->device_id) ){
        //     $response["message"] = "El device id es requerido";
        //     return response()->json($response, 504);
        // }

        // if( empty($request->codigo) ){
        //     $response["message"] = "El codigo es requerido";
        // }

        //revisa el codigo
        //$codigo = Codigos::where("codigo",$request->codigo)->first();

        $codigo = Codigos::where("codigo", $request->codigo)->first();

        // error_log( $request->codigo );

        if ( empty( $codigo ) ) {
            
            $response["estatus"] = 1;
            $response["mensaje"] = "No se encontró el código de tu institución.";
            
            return response()->json($response, 504);
        }else{
            
            $institucion = Institution::find($codigo->id_institucion);

            if( $institucion ){

                if( $institucion->estatus === 0 ){
                    // $response["isInactive"] = true;
                    $response["estatus"] = 0;
                    $response["mensaje"] = "La institución se encuentra inactiva, comunícate con el administrador.";
                    // $error = array("mensaje" => array("La institución se encuentra inactiva, comunícate con el administrador."));
                    // $response["errors"] = $error;
                    return response()->json($response, 504);
                }

            }else{

                $response["estatus"] = 2;

            }
           
        }

        $users_app = UsersApp::where("device_id", $request->device_id)->first();

        if ($users_app != null) {

            $user_id = UsersApp::max('id');
            // $new_user_id = $user_id + 1;

            UsersApp::where("device_id", $request->device_id)->delete();

            // UsersApp::where("id", $users_app->id)->update(["id_codigo" => $codigo->id, "id" => $new_user_id ]);
            $user = new UsersApp();

            $user->id_codigo = $codigo->id;
            $user->device_id = $request->device_id;
            $user->status    = 1;

            $user->save();


            $delete = AppUserTokenSession::where("user_app_id", $users_app->id)->delete();

            //Generamos el token
            $app_user_token_sessions = new AppUserTokenSession();
            $app_user_token_sessions->access_token = md5(date("Y-m-d H:i:s") . "-" . $user->id);
            $app_user_token_sessions->user_app_id = $user->id;
            $app_user_token_sessions->expirated_at = Carbon::now()->addYears(2);
            $app_user_token_sessions->save();


            $institucion = Institution::find($codigo->id_institucion);
            
            $response["estatus"] = true;
            $response["mensaje"] = "Ingreso correcto.";
            $response["token"] = $app_user_token_sessions->access_token;
            $response["user_id"] = $user->id;
            $response["codigo_temp"] = $codigo->id;

            return response()->json($response, 200);

        } else {

            if ($codigo) {

                $user = new UsersApp();
                $user->device_id = $request->device_id;
                $user->id_codigo = $codigo->id;
                $user->status = 1;

                if ($user->save()) {

                    //Generamos el token
                    $app_user_token_sessions = new AppUserTokenSession();
                    $app_user_token_sessions->access_token = md5(date("Y-m-d H:i:s") . "-" . $user->id);
                    $app_user_token_sessions->user_app_id = $user->id;
                    $app_user_token_sessions->expirated_at = Carbon::now()->addYears(2);
                    $app_user_token_sessions->save();

                    $response["estatus"] = true;
                    $response["mensaje"] = "Te hemos registrado correctamente, bienvenido a detente.";
                    $response["token"] = $app_user_token_sessions->access_token;
                    $response["user_id"] = $user->id;
                    $response["codigo_temp"] = $codigo->id;
                    return response()->json($response, 200);

                } else {
                    $error = array("save" => array("Error al guardar usuario."));
                    $response["errors"] = $error;
                    return response()->json($response, 504);
                }

            } else {

                // $error = { "codigo": array( "No se encontró el código de tu institución." ) };
                // $error = array("codigo" => array("No se encontró el código de tu institución."));
                // $response["errors"] = $error;
                $response["mensaje"] = "No se encontró el código de tu institución.";
                return response()->json($response, 504);

            }

            //No existe el usuario o credenciales incorrectas
            //  $response["message"] = "Correo electrónico o contraseña incorrectos, verifica el acceso a tu cuenta.";
            //  return response()->json($response, 504);


        }

    }

    public function institucion(Request $request)
    {

        // $response["estatus"] = 0;

        $validator = \Validator::make($request->all(),
            [
                'id' => 'required|numeric',
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }

        $user_app = UsersApp::find($request->id);

        if( $user_app ){
            $response["institucion"] = array("estatus" => 2);            
        }

        $users_app = UsersApp::find($request->id)->makeHidden(['created_at', 'updated_at']);
        $codigo = Codigos::find($users_app->id_codigo);
        $institucion = Institution::find($codigo->id_institucion);

        if ($institucion) {

            if( $institucion->estatus === 0 ){

                $response["estatus"] = 0;
                $response["institucion"] = array("estatus" => 0);                

            }else{

                $response["estatus"] = 1;
                $response["institucion"] =  array( "id" => $institucion->id, 
                                                   "name" => $institucion->name,
                                                   "logo" => $institucion->logo, 
                                                   "phone" => $institucion->phone,
                                                   "direction" => $institucion->direction,
                                                   "contact" => $institucion->contact,
                                                   "email_contact" => $institucion->email_contact,
                                                   "estatus" => 1,
                                                   "state" => $institucion->state,
                                                   "city" => $institucion->city,
                                                   "sector" => $institucion->sector,
                                                   "codigo" => $institucion->codigo,
                                                ); //$institucion;
                $response["usuario"] = $users_app;

            }

        }else{
            $response["institucion"] = array("estatus" => 2);
        }

        return response()->json($response, 200);

    }

    public function telefonos(Request $request)
    {

        $validator = \Validator::make($request->all(),
            [
                'id' => 'required',
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }

        $telefonos = Telefonos::where("id_institucion", $request->id)->orderBy("orden", "ASC")->get();

        $response["telefonos"] = $telefonos;

        return response()->json($response, 200);

    }

    public function iniciarReporteChat($id_institucion, $user)
    {

        //$tipo        

        if ($user->status == 0) {

            $response["estatus"] = false;
            $response["tipo"] = "usuario_bloqueado";
            $response["mensaje"] = "Tu usuario ha sido bloqueado.";

            return $response;
        }


        $inst = Institution::find($id_institucion);

        if( $inst ){
            if( $inst->estatus === 0 ){
                $response["estatus"] = false;
                $response["tipo"] = "usuario_bloqueado";
                $response["mensaje"] = "La institución se encuentra inactiva, comunicate con el administrador.";
            }
        }

        $horario = Horarios::where("id_institucion", $id_institucion)->first();
        error_log( "HORARIO =>". $horario );
        if($horario){

            $horario_semana = json_decode($horario->horarios);
    
            $dia_de_reporte = array_filter($horario_semana, function ($value) {
                $dayOfTheWeek = Carbon::now()->dayOfWeek;
                return $value->dia == ($dayOfTheWeek + 1);
            });
        }

        $preguntas = Preguntas::where("id_institucion", $id_institucion)->get();

        $dayOfTheWeek = Carbon::now()->dayOfWeek;

        //VACACIONES

        if( $horario){

            if ($horario->vacaciones_reporte_activo == 1) {
    
                $vacaciones = Vacaciones::where("id_institucion", $id_institucion)->get();
                $fecha_server_report = Carbon::now();
    
                foreach ($vacaciones as $key => $value) {
                    // error_log( $fecha_server_report ."<". $value->fecha_final ."==". $fecha_server_report .">". $value->fecha_inicial );
                    if ($fecha_server_report < $value->fecha_final and $fecha_server_report > $value->fecha_inicial) {
    
                        $response["estatus"] = true;
                        $response["tipo"] = "vacaciones";
                        if( $horario->msj_vacaciones ){
                            $response["mensaje"] = $horario->msj_vacaciones;
                        }else{
                            $response["mensaje"] = "Gracias por tu reporte, estamos en periodo vacacional, tu incidente será atendido a la brevedad.";
                        }
    
                        return $response;
                    }
    
                }
    
            }

            // error_log( $dia_de_reporte[$dayOfTheWeek]->inicial );

            if ( $dia_de_reporte[$dayOfTheWeek]->inicial ) {
    
                $fecha_hoy = Carbon::now()->format('Y-m-d H:i:s');
                $fecha_inicial = date('Y-m-d ' . $dia_de_reporte[$dayOfTheWeek]->inicial . ":00");
                $fecha_final   = date('Y-m-d ' . $dia_de_reporte[$dayOfTheWeek]->final . ":00");
                
    
                if ($fecha_hoy > $fecha_inicial && $fecha_hoy < $fecha_final) {
                    //dentro de horario
                    $response["estatus"] = true;
                    $response["tipo"] = "dentro_de_horario";
                    if (empty($preguntas[0]->respuesta)) {
                        $response["mensaje"] = "Gracias por tu reporte, tu mensaje ha sido enviado con éxito";
                    } else {
                        $response["mensaje"] = $preguntas[0]->respuesta;
                    }
                    return $response;
                } else {
                    //fuera de horario                
                    if ($horario->fuera_horario_activo == 1) {
                        $response["estatus"] = true;
                        $response["tipo"] = "mensaje_fuera_de_horario";
                        if( $horario->msj_fuera_horario ){
                            $response["mensaje"] = $horario->msj_fuera_horario;
                        }else{
                            $response["mensaje"] = "Gracias por tu reporte, estamos fuera de horario, tu incidente será atendido a la brevedad.";
                        }
                        return $response;
                    }
                }
    
            }

        }

        if (empty($preguntas[0]->respuesta)) {
            $response["mensaje"] = "Gracias por tu reporte, tu mensaje ha sido enviado con éxito";
        } else {
            $response["mensaje"] = $preguntas[0]->respuesta;
        }

        $response["estatus"] = true;
        $response["tipo"] = "mensaje_sin_config";
        // $response["mensaje"] = "Tu mensaje ha sido enviado con éxito te contactaremos muy pronto";

        return $response;

    }

    public function iniciar_reporte(Request $request)
    {

        $validator = \Validator::make($request->all(),
            [
                'id_institucion' => 'required'
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }

        $preguntas = Preguntas::where("id_institucion", $request->id_institucion)->get();

        //madamos las preguntas - retornar la primer pregunta 
        if ($preguntas[0]->mensaje) {
            $response["pregunta"] = $preguntas[0]->mensaje;
        } else {
            $response["pregunta"] = "Hola, ¿qué deseas reportar?";
        }

        return response()->json($response, 200);
    }

    function mime2ext($mime)
    {
        $all_mimes = '{"png":["image\/png","image\/x-png"],"bmp":["image\/bmp","image\/x-bmp",
        "image\/x-bitmap","image\/x-xbitmap","image\/x-win-bitmap","image\/x-windows-bmp",
        "image\/ms-bmp","image\/x-ms-bmp","application\/bmp","application\/x-bmp",
        "application\/x-win-bitmap"],"gif":["image\/gif"],"jpeg":["image\/jpeg",
        "image\/pjpeg"],"xspf":["application\/xspf+xml"],"vlc":["application\/videolan"],
        "wmv":["video\/x-ms-wmv","video\/x-ms-asf"],"au":["audio\/x-au"],
        "ac3":["audio\/ac3"],"flac":["audio\/x-flac"],"ogg":["audio\/ogg",
        "video\/ogg","application\/ogg"],"kmz":["application\/vnd.google-earth.kmz"],
        "kml":["application\/vnd.google-earth.kml+xml"],"rtx":["text\/richtext"],
        "rtf":["text\/rtf"],"jar":["application\/java-archive","application\/x-java-application",
        "application\/x-jar"],"zip":["application\/x-zip","application\/zip",
        "application\/x-zip-compressed","application\/s-compressed","multipart\/x-zip"],
        "7zip":["application\/x-compressed"],"xml":["application\/xml","text\/xml"],
        "svg":["image\/svg+xml"],"3g2":["video\/3gpp2"],"3gp":["video\/3gp","video\/3gpp"],
        "mp4":["video\/mp4"],"m4a":["audio\/x-m4a"],"f4v":["video\/x-f4v"],"flv":["video\/x-flv"],
        "webm":["video\/webm"],"aac":["audio\/x-acc"],"m4u":["application\/vnd.mpegurl"],
        "pdf":["application\/pdf","application\/octet-stream"],
        "pptx":["application\/vnd.openxmlformats-officedocument.presentationml.presentation"],
        "ppt":["application\/powerpoint","application\/vnd.ms-powerpoint","application\/vnd.ms-office",
        "application\/msword"],"docx":["application\/vnd.openxmlformats-officedocument.wordprocessingml.document"],
        "xlsx":["application\/vnd.openxmlformats-officedocument.spreadsheetml.sheet","application\/vnd.ms-excel"],
        "xl":["application\/excel"],"xls":["application\/msexcel","application\/x-msexcel","application\/x-ms-excel",
        "application\/x-excel","application\/x-dos_ms_excel","application\/xls","application\/x-xls"],
        "xsl":["text\/xsl"],"mpeg":["video\/mpeg"],"mov":["video\/quicktime"],"avi":["video\/x-msvideo",
        "video\/msvideo","video\/avi","application\/x-troff-msvideo"],"movie":["video\/x-sgi-movie"],
        "log":["text\/x-log"],"txt":["text\/plain"],"css":["text\/css"],"html":["text\/html"],
        "wav":["audio\/x-wav","audio\/wave","audio\/wav"],"xhtml":["application\/xhtml+xml"],
        "tar":["application\/x-tar"],"tgz":["application\/x-gzip-compressed"],"psd":["application\/x-photoshop",
        "image\/vnd.adobe.photoshop"],"exe":["application\/x-msdownload"],"js":["application\/x-javascript"],
        "mp3":["audio\/mpeg","audio\/mpg","audio\/mpeg3","audio\/mp3"],"rar":["application\/x-rar","application\/rar",
        "application\/x-rar-compressed"],"gzip":["application\/x-gzip"],"hqx":["application\/mac-binhex40",
        "application\/mac-binhex","application\/x-binhex40","application\/x-mac-binhex40"],
        "cpt":["application\/mac-compactpro"],"bin":["application\/macbinary","application\/mac-binary",
        "application\/x-binary","application\/x-macbinary"],"oda":["application\/oda"],
        "ai":["application\/postscript"],"smil":["application\/smil"],"mif":["application\/vnd.mif"],
        "wbxml":["application\/wbxml"],"wmlc":["application\/wmlc"],"dcr":["application\/x-director"],
        "dvi":["application\/x-dvi"],"gtar":["application\/x-gtar"],"php":["application\/x-httpd-php",
        "application\/php","application\/x-php","text\/php","text\/x-php","application\/x-httpd-php-source"],
        "swf":["application\/x-shockwave-flash"],"sit":["application\/x-stuffit"],"z":["application\/x-compress"],
        "mid":["audio\/midi"],"aif":["audio\/x-aiff","audio\/aiff"],"ram":["audio\/x-pn-realaudio"],
        "rpm":["audio\/x-pn-realaudio-plugin"],"ra":["audio\/x-realaudio"],"rv":["video\/vnd.rn-realvideo"],
        "jp2":["image\/jp2","video\/mj2","image\/jpx","image\/jpm"],"tiff":["image\/tiff"],
        "eml":["message\/rfc822"],"pem":["application\/x-x509-user-cert","application\/x-pem-file"],
        "p10":["application\/x-pkcs10","application\/pkcs10"],"p12":["application\/x-pkcs12"],
        "p7a":["application\/x-pkcs7-signature"],"p7c":["application\/pkcs7-mime","application\/x-pkcs7-mime"],"p7r":["application\/x-pkcs7-certreqresp"],"p7s":["application\/pkcs7-signature"],"crt":["application\/x-x509-ca-cert","application\/pkix-cert"],"crl":["application\/pkix-crl","application\/pkcs-crl"],"pgp":["application\/pgp"],"gpg":["application\/gpg-keys"],"rsa":["application\/x-pkcs7"],"ics":["text\/calendar"],"zsh":["text\/x-scriptzsh"],"cdr":["application\/cdr","application\/coreldraw","application\/x-cdr","application\/x-coreldraw","image\/cdr","image\/x-cdr","zz-application\/zz-winassoc-cdr"],"wma":["audio\/x-ms-wma"],"vcf":["text\/x-vcard"],"srt":["text\/srt"],"vtt":["text\/vtt"],"ico":["image\/x-icon","image\/x-ico","image\/vnd.microsoft.icon"],"csv":["text\/x-comma-separated-values","text\/comma-separated-values","application\/vnd.msexcel"],"json":["application\/json","text\/json"]}';
        $all_mimes = json_decode($all_mimes, true);
        foreach ($all_mimes as $key => $value) {
            if (array_search($mime, $value) !== false) return $key;
        }
        return false;
    }

    //base 64
    private function createMultimedia($img, $id_incidente, $chat_id, $carpeta)
    {

        $folderPath = "assets/movil/" . md5($id_incidente) . "/" . $carpeta . "/";

        $image_parts = explode(";base64,", $img);
        $image_type_aux = explode($carpeta . "/", $image_parts[0]);
        $image_type = $image_type_aux[1];
        $image_base64 = base64_decode($image_parts[1]);


        if ($carpeta == "image") {
            $file = $folderPath . uniqid() . '.' . $image_type;
        }

        if ($carpeta == "audio") {
            // $mime_type = finfo_buffer(finfo_open(), $image_base64, FILEINFO_MIME_TYPE);
            // $extension = $this->mime2ext($mime_type);
            // $file = uniqid() .'.'. $extension;
            // $file_dir = $folderPath . uniqid() .'.'. $extension;
            // if (!file_exists($folderPath)) {
            //     mkdir($folderPath, 0775, true);
            // }
            // file_put_contents($file_dir, $image_base64); // save
            // error_log($extension);
            $file = $folderPath . uniqid() . '.' . $image_type;
        }

        if ($carpeta == "video") {
            $file = $folderPath . uniqid() . '.' . $image_type;
        }


        if (!file_exists($folderPath)) {
            mkdir($folderPath, 0775, true);
        }

        file_put_contents($file, $image_base64);

        Chats::where("id", $chat_id)->update([$carpeta => $file]);

    }

    private function createMultimediaFile($request, $id_incidente, $chat_id, $carpeta)
    {


        //ESTE ES UN CHAT
        $folderPath = "assets/movil/" . md5($id_incidente) . "/" . $carpeta . "/";

        if (!file_exists($folderPath)) {
            mkdir($folderPath, 0775, true);
        }

        if ($request->imagen) {

            if (!file_exists($folderPath)) {
                mkdir($folderPath, 0775, true);
            }

            foreach ($request->imagen as $file) {

                $file_name = md5(date("Y-m-d H:i:s")) . rand(99, 9999) . "." . $file->getClientOriginalExtension();
                $file->move($folderPath, $file_name);

            }

        }

        if ($request->audio) {

            if (!file_exists($folderPath)) {
                mkdir($folderPath, 0775, true);
            }

            foreach ($request->audio as $file) {

                $file_name = md5(date("Y-m-d H:i:s")) . rand(99, 9999) . "." . $file->getClientOriginalExtension();
                $file->move($folderPath, $file_name);

            }

        }

        if ($request->video) {

            if (!file_exists($folderPath)) {
                mkdir($folderPath, 0775, true);
            }

            foreach ($request->video as $file) {

                $file_name = md5(date("Y-m-d H:i:s")) . rand(99, 9999) . "." . $file->getClientOriginalExtension();
                $file->move($folderPath, $file_name);

            }

        }


        if ($chat_id == null) {
            //SI EL ID DEL CHAT LO RECIBE NULO ES UN REPORTE EL CUAL PUEDE REIBIR VARIOS ARCHIVOS
            //se añadira en miltimedia del incidiente
            // { multimedia: [ { "type":"imagen",uri:"" } ] }

            $datos = array("multimedia" => array("type" => $carpeta, "url" => $folderPath . $file_name));
            Incidentes::where("id", $id_incidente)->update(["multimedia" => json_encode($datos)]);

        } else {

            // $file_name = md5(date("Y-m-d H:i:s")).".".$multimedia->getClientOriginalExtension();
            // $multimedia->file('video')->move($folderPath, $file_name );

            Chats::where("id", $chat_id)->update([$carpeta => $folderPath . $file_name, "type_multimedia" => 1]);
            // $this->type_multimedia( $carpeta )

        }

    }

    // private function type_multimedia( $type ){
    //     if( $type == "imagen" ){
    //         return 1;
    //     }

    //     if( $type == "audio" ){
    //         return 2;
    //     }

    //     if( $type == "video" ){
    //         return 3;
    //     }
    // }

    public function reportar(Request $request)
    {

        // validar que mensaje de respuesta dependiendo si es vacaciones, horarios        
        //en caso de que aya pregunta retornar si no pues no crearla

        $response["estatus"] = false;        

        $validator = \Validator::make($request->all(),
            [
                'id_user' => 'required',
                // 'codigo'  => 'required',
                'mensaje' => 'required',
                'id_institucion' => 'required'
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }

        $user = UsersApp::find($request->id_user);        

        if( empty( $user) ){     
                   
            return response()->json($response, 200);
        }

        $response = $this->iniciarReporteChat($request->id_institucion, $user);

        error_log( "REPORTAR => ". print_r( $response, true ) );

        if ($response["estatus"] == false) {            
            return response()->json($response, 200);
        }

        $codigo = Codigos::find($user->id_codigo);

        if( empty( $codigo) ){     
            $response["mensaje"] = "No se encontró el código.";                  
            return response()->json($response, 200);
        }

        $incidente = new Incidentes();

        $incidente->id_user = $request->id_user;
        $incidente->codigo  = $codigo->codigo;
        $incidente->mensaje = $request->mensaje;
        $incidente->id_institucion = $request->id_institucion;
        $incidente->estatus   = 1;
        $incidente->id_codigo = $codigo->id;

        if ($incidente->save()) {                        

            $institucion = Institution::find( $request->id_institucion );
            $url    = url("/assets/images/calificacion/10-s.png");
            $master = User::where( "user_profile_id", 3)->where("id_institucion", $request->id_institucion)->first();

            $chat = false;

            try {
                
                \Mail::send("mail.incidente_asignado", ["url" => $url, "nombre_institucion" => $institucion->name, "id_reporte" => $incidente->id, "chat" => $chat ], function ($message) use ($master) {
                    $message->to($master->email)->subject('Nuevo Reporte');
                });
            } catch (Exception $e) {
                echo 'Excepción capturada: ',  $e->getMessage(), "\n";
            }

           

            // $chat = new Chats();
            // $chat->id_incidente = $incidente->id;
            // $chat->id_user      = $request->id_user;
            // $chat->mensaje      = $request->mensaje;
            // $chat->user_type    = 1; //1 es el usuario que reporta

            // if($chat->save()){

            // if( $request->img ){
            //     $this->createMultimedia( $request->img, $incidente->id, $chat->id, "image" );
            // }

            $multimedia = array();

            if ($request->imagen) {

                $carpeta = "image";
                $folderPath = "assets/movil/" . md5($incidente->id) . "/" . $carpeta . "/";

                if (!file_exists($folderPath)) {
                    mkdir($folderPath, 0775, true);
                }

                foreach ($request->imagen as $file) {

                    $file_name = md5(date("Y-m-d H:i:s")) . rand(99, 9999) . "." . $file->getClientOriginalExtension();
                    $file->move($folderPath, $file_name);

                    $datos = array("multimedia" => array("type" => $carpeta, "url" => $folderPath . $file_name));
                    array_push($multimedia, $datos);

                }

                // Incidentes::where("id", $incidente->id)->update(["multimedia" => json_encode( $datos ) ]);
                // $this->createMultimediaFile( $request, $incidente->id, null, "imagen" );

            }

            if ($request->audio) {

                $carpeta = "audio";
                $folderPath = "assets/movil/" . md5($incidente->id) . "/" . $carpeta . "/";

                if (!file_exists($folderPath)) {
                    mkdir($folderPath, 0775, true);
                }

                foreach ($request->audio as $file) {

                    $file_name = md5(date("Y-m-d H:i:s")) . rand(99, 9999) . "." . $file->extension();
                    $file->move($folderPath, $file_name);

                    $datos = array("multimedia" => array("type" => $carpeta, "url" => $folderPath . $file_name));
                    array_push($multimedia, $datos);

                }

                // Incidentes::where("id", $incidente->id)->update(["multimedia" => json_encode( $datos ) ]);
                // $this->createMultimediaFile( $request, $incidente->id, null, "audio" );

            }

            if ($request->video) {

                $carpeta = "video";
                $folderPath = "assets/movil/" . md5($incidente->id) . "/" . $carpeta . "/";

                if (!file_exists($folderPath)) {
                    mkdir($folderPath, 0775, true);
                }

                foreach ($request->video as $file) {

                    $file_name = md5(date("Y-m-d H:i:s")) . rand(99, 9999) . "." . $file->extension();
                    $file->move($folderPath, $file_name);

                    $datos = array("multimedia" => array("type" => $carpeta, "url" => $folderPath . $file_name));
                    array_push($multimedia, $datos);

                }

                // Incidentes::where("id", $incidente->id)->update(["multimedia" => json_encode( $datos ) ]);
                // $this->createMultimediaFile( $request, $incidente->id, null, "video" );

            }

            if( count($multimedia) > 0 ){
                Incidentes::where("id", $incidente->id)->update(["multimedia" => json_encode($multimedia)]);
            }


            $chat = new Chats();
            $chat->id_incidente = $incidente->id;
            $chat->id_user = $request->id_user;
            $chat->mensaje = $request->mensaje;
            $chat->user_type = 1;
            $chat->estatus   = 0;

            $chat->save();

            // }

            // $response["mensaje"] = "Tu mensaje ha sido enviado con éxito te contactaremos muy pronto";
            $response["estatus"] = true;

        } else {
            $response["mensaje"] = "Gracias por tu reporte, tu mensaje ha sido enviado con éxito";
        }
        

        return response()->json($response, 200);

    }

    public function incidentes(Request $request)
    {

        $validator = \Validator::make($request->all(),
            [
                'id_user' => 'required',
                'pagina' => 'required'
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }

        $user = UsersApp::where("id", $request->id_user)->first();        

        $codigos = Codigos::where("id", $user->id_codigo)->first();

        $incidente = Incidentes::where("id_user", $request->id_user)->where("codigo", $codigos->codigo)->orderBy("id", "DESC")->paginate($request->pagina);
        $response["incidente"] = $incidente;

        return response()->json($response, 200);

    }

    public function incidentes_chats(Request $request)
    {

        $response = array();

        $validator = \Validator::make($request->all(),
            [
                'id_user' => 'required',
                'pagina' => 'required'
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }

        $user = UsersApp::where("id", $request->id_user)->first();        

        if( !$user ){
            return response()->json($response, 200);
        }

        $codigos = Codigos::where("id", $user->id_codigo)->first();

        $incidente = Incidentes::where("id_user", $request->id_user)->where("codigo", $codigos->codigo)->orderBy("id", "DESC")->paginate($request->pagina);
        $response["incidente"] = $incidente;


                
        // $institutions = Institution::find( $codigos->id_institucion );
        
        // $incidentes = Incidentes::where("id_institucion", $institutions->id)->where("id_user", $request->id_user)
        //                         ->pluck("id")->toArray();
                                                


        foreach ($incidente as $key => $inci) {
            
            $chats = Chats::where("id_incidente", $inci->id)->where("estatus", 0)->count();
            // $chats = Chats::whereIn("id_incidente",$incidentes)->where("user_type", 2)->where("estatus", 0)->count();                             
            
            if( $chats > 0 ){
                $incidente[$key]["chats_pendientes"] = true;
            }else{
                $incidente[$key]["chats_pendientes"] = false;
            }
            $incidente[$key]["chats_pendientes_num"] = $chats;
        }

        return response()->json($response, 200);

    }

    //chats

    public function registro_chat(Request $request)
    {

        $response["status"] = false;

        $validator = \Validator::make($request->all(),
            [
                'id_incidente' => 'required',
                'id_user' => 'required',
                // 'mensaje'      => 'required|max:255', 
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }

        //si el chat es nuevo mostrar segunda pregunta
        if (empty($request->mensaje)) {
            $mensaje_chat = "";
        } else {
            $mensaje_chat = $request->mensaje;
        }


        $chat = new Chats();

        $chat->id_incidente = $request->id_incidente;
        $chat->id_user = $request->id_user;
        $chat->user_type = 1;//$request->user_type;
        $chat->mensaje = $mensaje_chat;
        //$chat->save()
        if ($chat->save()) {

            if ($request->imagen) {

                // $carpeta = "image";
                // $folderPath = "assets/movil/".md5($request->id_incidente)."/".$carpeta."/";

                // if (!file_exists($folderPath)) {
                //     mkdir($folderPath, 0775, true);
                // }

                // $file_name = md5(date("Y-m-d H:i:s")).".".$request->file("imagen")->getClientOriginalExtension();
                // $request->file('imagen')->move($folderPath, $file_name );

                // Chats::where("id", $chat->id)->update([ $carpeta => $folderPath.$file_name, "type_multimedia" => 1 ]);

                $this->createMultimediaFile($request, $request->id_incidente, $chat->id, "image");
            }

            if ($request->audio) {
                // $carpeta = "audio";
                // $folderPath = "assets/movil/".md5($request->id_incidente)."/".$carpeta."/";

                // if (!file_exists($folderPath)) {
                //     mkdir($folderPath, 0775, true);
                // }

                // $file_name = md5(date("Y-m-d H:i:s")).".".$request->file("audio")->getClientOriginalExtension();
                // $request->file('audio')->move($folderPath, $file_name );

                // Chats::where("id", $chat->id)->update([ $carpeta => $folderPath.$file_name, "type_multimedia" => 1 ]);            
                $this->createMultimediaFile($request, $request->id_incidente, $chat->id, "audio");
            }

            if ($request->video) {
                $this->createMultimediaFile($request, $request->id_incidente, $chat->id, "video");
                // $carpeta = "video";
                // $folderPath = "assets/movil/".md5($request->id_incidente)."/".$carpeta."/";

                // if (!file_exists($folderPath)) {
                //     mkdir($folderPath, 0775, true);
                // }

                // $file_name = md5(date("Y-m-d H:i:s")).".".$request->file("video")->getClientOriginalExtension();
                // $request->file('video')->move($folderPath, $file_name );

                // Chats::where("id", $chat->id)->update([ $carpeta => $folderPath.$file_name, "type_multimedia" => 1 ]);            
            }

            $chat_num = Chats::where("id_incidente", $request->id_incidente)->count();

            $user = UsersApp::find($request->id_user);

            if ($chat_num <= 3) {

                // $user      = UsersApp::find($request->id_user);
                $codigo    = Codigos::find($user->id_codigo);
                $preguntas = Preguntas::where("id_institucion", $codigo->id_institucion)->get();

                if (count($preguntas) == 0) {

                    for ($contador = 1; $contador <= 2; $contador = $contador + 1) {

                        $preg = new Preguntas();
                        $preg->id_institucion = $codigo->id_institucion;
                        $preg->save();

                    }

                    $preguntas = Preguntas::where("id_institucion", $codigo->id_institucion)->get();
                }


                if (empty($preguntas[1]->respuesta)) {
                    $mensaje = "Gracias por tu reporte, tu mensaje ha sido enviado con éxito";
                } else {
                    $mensaje = $preguntas[1]->respuesta;
                }

                $chat = new Chats();

                $chat->id_incidente = $request->id_incidente;
                $chat->id_user = 0;
                $chat->user_type = 2;//$request->user_type;
                $chat->mensaje = $mensaje;
                $chat->save();

                $notificaciones = NotificacionesUsuario::where("id_user", $request->id_user)->first();

                if( $notificaciones ){

                    if( $notificaciones->token ){

                        $response["RESPONSE"]["UUID"] = $notificaciones->token; 
                        $response["RESPONSE"]["TEXTO_NOTIFICACION"] = "Tienes un mensaje nuevo";
                        $response["RESPONSE"]["TITLE"] = "Notificación";
                        $response["RESPONSE"]["DATA"] = array( "tipo" => "chat", "id_incidente" => $request->id_incidente );                                        

                        Pastora::sendPushNotification( $response );

                    }

                }   

            }

            //veificar si esta dentro, fuera de horario y vacaciones para generar un mensaje de horarios
            
            //Por ahora se envia solo a un asigando
            // $url = url("/assets/images/calificacion/10-s.png");               

            // try {
            //     \Mail::send("mail.incidente_asignado", ["url" => $url, "nombre_institucion" => $institucion->name, "id_reporte" => $incidente->id, $chat => true ], function ($message) use ($user_asignado) {
            //         $message->to($user_asignado->email)->subject('Reporte');
            //     });
            // } catch (Exception $e) {
            //     echo 'Excepción capturada: ',  $e->getMessage(), "\n";
            // }
            
            $incidentes_resp = IncidentesResponsables::where("id_incidente", $request->id_incidente)->pluck("id_user")->toArray();
            $users = User::whereIn("id", $incidentes_resp)->get();

            if( count($users) > 0 ){
                
                $chat = true;
                $url = url("/assets/images/calificacion/10-s.png");                    
                
                $codigo = Codigos::find( $user->id_codigo );
                $institucion = Institution::find($codigo->id_institucion  );
                $incidente   = Incidentes::find( $request->id_incidente ); 
                
                error_log($institucion);
                error_log($incidente);

                foreach ($users as $key => $user) {
                   try {
                        \Mail::send("mail.incidente_asignado", ["url" => $url, "nombre_institucion" => $institucion->name, "id_reporte" => $incidente->id, "chat" => $chat ], function ($message) use ($user) {
                            $message->to($user->email)->subject('Reporte');
                        });
                    } catch (Exception $e) {
                        echo 'Excepción capturada: ',  $e->getMessage(), "\n";
                    } 
                }
            }
            
            $response["mensaje"] = "El mensaje se registró correctamente";
            $response["status"] = true;
        } else {
            $response["mensaje"] = "¡Uy! Algo salió mal. No se pudo registrar el mensaje.";
        }

        return response()->json($response, 200);

    }

    public function chat_refresh(Request $request)
    {

        $this->validate(
            $request,
            [
                'id_incidente' => 'required',
                // 'user_type'    => 'required'                                            
            ]
        );
        //$request->user_type
        $chat = Chats::where("id_incidente", $request->id_incidente)->where("user_type", 2)->where("estatus", 0)->orderBy('id', 'DESC')->get();

        $response["chat"] = $chat;

        return response()->json($response, 200);

    }

    public function chat(Request $request)
    {

        // $response["status"] = false;

        $this->validate(
            $request,
            [
                'id_incidente' => 'required',
                // 'id_user'      => 'required',                                            
            ]
        );

        $chat_num = Chats::where("id_incidente", $request->id_incidente)->count();

        //->where( "id_user", $request->id_user )

        $incidente = Incidentes::where("id", $request->id_incidente)->first();

        if ($chat_num == 1) {
            $preguntas = Preguntas::where("id_institucion", $incidente->id_institucion)->get();

            if (empty($preguntas[1]->mensaje)) {
                $mensaje_resp = "Continúa aquí tu reporte";
            } else {
                $mensaje_resp = $preguntas[1]->mensaje;
            }

            $chat = new Chats();
            $chat->id_incidente = $incidente->id;
            $chat->id_user = 0;
            $chat->mensaje = $mensaje_resp;
            $chat->user_type = 2; //1 es el usuario que reporta
            $chat->save();

            $incidente = Incidentes::find($request->id_incidente);
            $notificaciones = NotificacionesUsuario::where("id_user", $incidente->id_user)->first();

            if( $notificaciones ){

                if( $notificaciones->token ){

                    $response["RESPONSE"]["UUID"] = $notificaciones->token; 
                    $response["RESPONSE"]["TEXTO_NOTIFICACION"] = "Tienes un mensaje nuevo";
                    $response["RESPONSE"]["TITLE"] = "Notificación";
                    $response["RESPONSE"]["DATA"] = array( "tipo" => "chat", "id_incidente" => $request->id_incidente );                                        

                    Pastora::sendPushNotification( $response );

                }

            }
        }        
        
        $horario = Horarios::where("id_institucion", $incidente->id_institucion)->first();

        if($horario){

            $horario_semana = json_decode($horario->horarios);
    
            $dia_de_reporte = array_filter($horario_semana, function ($value) {
                $dayOfTheWeek = Carbon::now()->dayOfWeek;
                return $value->dia == ($dayOfTheWeek + 1);
            });
        }

        $vacaciones_valid = false;

        $preguntas = Preguntas::where("id_institucion", $incidente->id_institucion)->get();

        $dayOfTheWeek = Carbon::now()->dayOfWeek;

        $chat = Chats::where("id_incidente", $request->id_incidente)->where("id_user", -1)->orderby('created_at','DESC')->first();//->take(1)->get();
        $valida_un_mensaje = false;        

        if( $chat ){

            $ultimo_chat_sistema = Carbon::parse($chat->created_at)->timestamp;
            $valor_tiempo = Carbon::now()->timestamp - $ultimo_chat_sistema;

            if( $valor_tiempo > 86400 ){
                $valida_un_mensaje = true;
            }            

        }else{
            $valida_un_mensaje = true;
        }

        if( $horario){

            if ($horario->vacaciones_reporte_activo == 1) {
    
                $vacaciones = Vacaciones::where("id_institucion", $incidente->id_institucion)->get();
                $fecha_server_report = Carbon::now();
    
                foreach ($vacaciones as $key => $value) {
                    // error_log( $fecha_server_report ."<". $value->fecha_final ."==". $fecha_server_report .">". $value->fecha_inicial );
                    if ($fecha_server_report < $value->fecha_final and $fecha_server_report > $value->fecha_inicial && $valida_un_mensaje) {
                        
                        $vacaciones_valid = true;

                        if( $horario->msj_vacaciones_inicial ){
                            // $response["mensaje"] = $horario->msj_vacaciones;
                            
                            $chat = new Chats();
                            $chat->id_incidente = $incidente->id;
                            $chat->id_user = 0;
                            $chat->mensaje = $horario->msj_vacaciones_inicial;
                            $chat->user_type = 2; //1 es el usuario que reporta
                            $chat->save();

                        }else{

                            $chat = new Chats();
                            $chat->id_incidente = $incidente->id;
                            $chat->id_user = 0;
                            $chat->mensaje = "Gracias por tu reporte, estamos en periodo vacacional, tu incidente será atendido a la brevedad.";
                            $chat->user_type = 2; //1 es el usuario que reporta
                            $chat->save();
                            
                        }
                            
                    }
    
                }
    
            }

            if ($dia_de_reporte[$dayOfTheWeek]->inicial) {
    
                $fecha_hoy = Carbon::now()->format('Y-m-d H:i:s');
                $fecha_inicial = date('Y-m-d ' . $dia_de_reporte[$dayOfTheWeek]->inicial . ":00");
                $fecha_final   = date('Y-m-d ' . $dia_de_reporte[$dayOfTheWeek]->final . ":00");
    
                if ($fecha_hoy > $fecha_inicial && $fecha_hoy < $fecha_final) {
                    //dentro de horario
                    // $response["estatus"] = true;
                    // $response["tipo"] = "dentro_de_horario";
                    // if (empty($preguntas[0]->respuesta)) {
                    //     $response["mensaje"] = "Gracias por tu reporte, tu mensaje ha sido enviado con éxito";
                    // } else {
                    //     $response["mensaje"] = $preguntas[0]->respuesta;
                    // }
                    // return $response;
                } else {
                    //fuera de horario                
                    if ($horario->fuera_horario_activo == 1 && $vacaciones_valid === false && $valida_un_mensaje ) {
                        // $response["estatus"] = true;
                        // $response["tipo"] = "mensaje_fuera_de_horario";
                        if( $horario->msj_fuera_horario ){
                            // $response["mensaje"] = $horario->msj_fuera_horario;
                            $chat = new Chats();
                            $chat->id_incidente = $incidente->id;
                            $chat->id_user = 0;
                            $chat->mensaje = $horario->msj_inicial;
                            $chat->user_type = 2; //1 es el usuario que reporta
                            $chat->save();
                        }else{
                            $chat = new Chats();
                            $chat->id_incidente = $incidente->id;
                            $chat->id_user = 0;
                            $chat->mensaje = "Gracias por tu reporte, estamos fuera de horario, tu incidente será atendido a la brevedad.";;
                            $chat->user_type = 2; //1 es el usuario que reporta
                            $chat->save();
                            // $response["mensaje"] = "Gracias por tu reporte, estamos fuera de horario, tu incidente será atendido a la brevedad.";
                        }
                        
                    }
                }
    
            }

        }
    

        $chats = Chats::where("id_incidente", $request->id_incidente)->orderBy('id', 'ASC')->get();
        // where("id_user", $request->id_user)->
    
        error_log("chat incidente =>". $request->id_incidente);
        Chats::where("id_incidente", $request->id_incidente)->where("estatus", 0)->where("user_type", 2)->update([ "estatus" => 1 ]);

        $response["chat"] = $chats;
        // $response["chats_pendientes"] = $chats_pendientes;
        

        return response()->json($response, 200);

    }

    public function mensaje_visto(Request $request)
    {

        $response["status"] = false;

        //es para identificar que ya fue visto
        $this->validate(
            $request,
            [
                'ids' => 'required',
                'id_incidente' => 'required',
            ]
        );

        $chats = Chats::where("id_incidente", $request->id_incidente)->whereIn('id', $request->ids)->update(["estatus" => 1]);

        if ($chats) {
            $response["status"] = true;
            $response["mensaje"] = "Los mensajes se actualizaron correctamente";
        } else {
            $response["mensaje"] = "¡Uy! Algo salió mal. No se pudieron actualizar los chats.";
        }

        return response()->json($response, 200);

    }

    public function preguntas(Request $request)
    {

        $response["status"] = false;

        $this->validate(
            $request,
            [
                'id_institucion' => 'required',
            ]
        );

        $preguntas = Preguntas::where("id_institucion", $request->id_institucion)->get();

        $response["preguntas"] = $preguntas;

        return response()->json($response, 200);

    }

    public function codigoUpdate(Request $request)
    {

        $response = array();
        // $response["mensaje"] = "";
        // $response["estatus"] = false;

        $validator = \Validator::make($request->all(),
            [
                'id_user' => 'required',
                'codigo' => 'required',
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }

        $codigo = Codigos::where("codigo", $request->codigo)->first();                        
        
        if ($codigo) {

            $institucion = Institution::find($codigo->id_institucion);

            if( $institucion ){

                if( $institucion->estatus === 0 ){
                    $response["mensaje"] = "La institución se encuentra inactiva, comunicate con el administrador.";
                    return response()->json($response, 504);
                }

            }else{            
                $response["mensaje"] = "No se encontró el código";
                return response()->json($response, 504);   
            }
            
            $user = UsersApp::find($request->id_user);            
            $user_id = UsersApp::max('id');

            if( empty($user) ){
                $response["mensaje"] = "¡Uy! Algo salió mal. No se pudo actualizar el codigo.";
                return response()->json($response, 504);   
            }
            
            UsersApp::where("id", $request->id_user)->delete();

            $user_new = new UsersApp();
            $user_new->id_codigo = $codigo->id;
            $user_new->status    = 1;
            $user_new->device_id = $user->device_id;
            // $nuevo_id_usuario = $user_id + 1;
            // $user->id        = $user_id + 1;
            
            if ( $user_new->save() ) {    
                
                // UsersApp::where("id", $request->id_user)->update(["id_codigo" => $codigo->id]);

                $delete = AppUserTokenSession::where("user_app_id", $request->id_user)->delete();
                
                //Generamos el token
                $app_user_token_sessions = new AppUserTokenSession();
                $app_user_token_sessions->access_token = md5(date("Y-m-d H:i:s") . "-" . $user_new->id);
                $app_user_token_sessions->user_app_id = $user_new->id;
                $app_user_token_sessions->expirated_at = Carbon::now()->addYears(2);
                $app_user_token_sessions->save();

        
                $institucion = Institution::find($codigo->id_institucion);
                $new_user = UsersApp::find( $user_new->id );

                $data = array( 
                                "usuario" => $new_user, 
                               "institucion" => $institucion,                             
                            );

                $response["mensaje"] = "El código se actualizó correctamente.";                
                $response["estatus"] = true;
                $response["token"]   = $app_user_token_sessions->access_token;

                $response["data"] = $data;

                return response()->json($response, 200);
            } else {
                $response["mensaje"] = "¡Uy! Algo salió mal. No se pudo actualizar el codigo.";
                return response()->json($response, 504);
            }

        } else {
            $response["mensaje"] = "No se encontró el codigo";
        }

        // $users_app = UsersApp::where("id", $request->id_user)->where( "id_codigo", $codigo->id )->first();                        

        return response()->json($response, 200);

    }

    public function comunicados(Request $request)
    {

        $validator = \Validator::make($request->all(),
            [
                'id_institucion' => 'required',
                'id_user' => 'required',
                'page' => 'required',
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }
        
        $user   = UsersApp::find($request->id_user);
        
        $comunicados_codigos = array();
        $comunicados_codigos = ComunicadosCodigos::where("id_codigo", $user->id_codigo)->pluck("id_comunicado")->toArray();
        
        
        $codigo      = Codigos::find($user->id_codigo);
        $codigo_c    = ComunicadosCodigos::where("id_codigo", 0)->get();
        // $codigo_c_id    = ComunicadosCodigos::where("id_codigo", 0)->pluck("id")->toArray();

        $ids_array = array();
        $ids_array_c = array();

        foreach( $codigo_c as $value ){
            
            $valida_c_all = Comunicados::where("id", $value->id_comunicado)->where("id_institucion", $codigo->id_institucion)->orderBy("id", "DESC")->get();

            if( count( $valida_c_all ) > 0 ){
                array_push($ids_array, $value->id);
                array_push($ids_array_c, $value->id_comunicado);
            }
            
        }

        // $comunicados_all = Comunicados::whereIn("id", $codigo_c)->where("id_institucion", $codigo->id_institucion)->orderBy("id", "DESC")->get();

        $merge  = array_merge( $comunicados_codigos, $ids_array );
        $merge2 = array_merge( $comunicados_codigos, $ids_array_c );                

        $comunicados = Comunicados::whereIn("id", $merge2)->orderBy("id", "DESC")->paginate($request->page);           
        $comunicados_count = ComunicadosVistas::whereIn("id_comunicado_codigos", $merge)->where("id_user", $request->id_user)->where("visto",0)->count();   

        $response["comunicados"] = $comunicados;
        $response["pendientes"] = $comunicados_count;
        

        return response()->json($response, 200);

    }


    public function comunicado(Request $request)
    {

        $validator = \Validator::make($request->all(),
            [
                'id' => 'required|numeric',
                'id_user' => 'required|numeric',
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }

        $comunicado = Comunicados::find($request->id);
        $comunicado_codigos = ComunicadosCodigos::where("id_comunicado", $comunicado->id)->first();

        // if( $comunicado->visto == 0 ){
        //     $comunicado->visto = 1;
        //     $comunicado->save();
        // }    

        //Cambia el comunicado a visto si es que existe
        //con usuarios nuevos no existe este conteo hasta que se genere un comunicado y ya este registrado
        ComunicadosVistas::where("id_comunicado_codigos", $comunicado_codigos->id)->where("id_user", $request->id_user)->update(["visto" => 1]);
        
        $com = array();

        $com["created_at"] = $comunicado->created_at;
        $com["updated_at"] = $comunicado->updated_at;
        $com["descripcion"] = $comunicado->descripcion;
        $com["dirigido"] = $comunicado->dirigido;
        $com["id_institucion"] = $comunicado->id_institucion;
        $com["id"] = $comunicado->id;
        $com["texto"] = $comunicado->texto;

        if (!empty($comunicado->url_img)) {
            $com["tipo"] = "imagen";
            $com["contenido"] = $comunicado->url_img;

            $response["comunicado"] = $com;
            return response()->json($response, 200);
        }

        if (!empty($comunicado->url_video)) {
            $com["tipo"] = "video";
            $com["contenido"] = $comunicado->url_video;
            $response["portada"] = url("assets/images/video_2.png");

            $response["comunicado"] = $com;
            return response()->json($response, 200);
        }

        if (!empty($comunicado->url_youtube)) {
            $com["tipo"] = "url";
            $com["contenido"] = $comunicado->url_youtube;

            $response["comunicado"] = $com;
            return response()->json($response, 200);
        }

        if (!empty($comunicado->url_pdf)) {
            $com["tipo"] = "pdf";
            $com["contenido"] = $comunicado->url_pdf;

            $response["comunicado"] = $com;
            return response()->json($response, 200);
        }

        $response["comunicado"] = $com;

        return response()->json($response, 200);
    }

    public function calificar(Request $request)
    {

        $response["estatus"] = false;

        $validator = \Validator::make($request->all(),
            [
                'id' => 'required|numeric',
                'calificacion' => 'required|numeric'
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }

        $update = Incidentes::where("id", $request->id)->update(["calificacion" => $request->calificacion]);

        if ($update) {
            $response["estatus"] = true;
            $response["mensaje"] = "El código se actualizó correctamente.";
        } else {
            $response["mensaje"] = "¡Uy! Algo salió mal. No se pudo calificar.";
        }

        return response()->json($response, 200);

    }

    public function logout(Request $request)
    {

        $response["estatus"] = false;

        $validator = \Validator::make($request->all(),
            [
                'id' => 'required|numeric',
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }

        NotificacionesUsuario::where("id_user", $request->id)->delete();

        $userDelete = UsersApp::where("id", $request->id)->delete();   
        
        // NotificacionesUsuario::where("id_user", $request->id);

        if ($userDelete) {
            $response["estatus"] = true;
            $response["mensaje"] = "La sesión se cerro correctamente.";
        } else {
            $response["estatus"] = true;
            $response["mensaje"] = "¡Uy! Algo salió mal. No se pudo cerrar sesión.";
        }

        return response()->json($response, 200);

    }

    public function home_tabs( Request $request ){
        
        $response["estatus"] = false;

        $validator = \Validator::make($request->all(),
            [                
                'id_institucion' => 'required',
                'id_user' => 'required',
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }
        
        // $user   = UsersApp::find($request->id_user);
        
        
        // $comunicados_codigos = ComunicadosCodigos::where("id_codigo", $user->id_codigo)->pluck("id_comunicado")->toArray();
        
        
        // $codigo      = Codigos::find($user->id_codigo);
        // $codigo_c    = ComunicadosCodigos::where("id_codigo", 0)->pluck("id_comunicado")->toArray();

        // $ids_array = array();

        // foreach( $codigo_c as $value ){

        //     $valida_c_all = Comunicados::where("id", $value)->where("id_institucion", $codigo->id_institucion)->orderBy("id", "DESC")->get();

        //     if( count( $valida_c_all ) > 0 ){
        //         array_push($ids_array, $value);
        //     }
            
        // }       

        // $merge = array_merge( $comunicados_codigos, $ids_array );    
          
        // $comunicados_count = Comunicados::whereIn("id", $merge)->where("visto",0)->count();   

        $comunicados_count = ComunicadosVistas::where("id_user", $request->id_user)->where("visto", 0)->count();

        // CONTEO DE MENSAJES SIN LEER

        $user_app = UsersApp::find( $request->id_user );
        $codigo   = Codigos::find($user_app->id_codigo);
        $institutions = Institution::find( $codigo->id_institucion );
        
        $incidentes = Incidentes::where("id_institucion", $institutions->id)->where("id_user", $request->id_user)
                                ->pluck("id")->toArray();
        
        //->where("id_user", $request->id_user)                                
        $chats = Chats::whereIn("id_incidente",$incidentes)->where("user_type", 2)->where("estatus", 0)->count();                             
        // $chats = Chats::where("id_user", $request->id_user)->where("user_type", 2)->where("estatus", 0)->count();

        
        $response["chats"] = $chats;
        $response["comunicados"] = $comunicados_count;

        if( $chats == 0 && $comunicados_count == 0 ){
            $response["estatus"] = false;
        }else{
            $response["estatus"] = true;
        }
        
        return response()->json($response, 200);

    }

    public function update_token( Request $request ){
        
        $response["estatus"] = false;

        $validator = \Validator::make($request->all(),
            [                
                'token_uid' => 'required',
                'id_user' => 'required',
            ]
        );

        if ($validator->fails()) {
            $response['errors'] = $validator->errors();
            return response()->json($response, 504);
        }


        $user_app = UsersApp::find( $request->id_user );

        if( $user_app ){
            // $notificaciones = NotificacionesPush
            $notificaciones = NotificacionesUsuario::where("id_user", $request->id_user)->count();

            if( $notificaciones > 0 ){
                                
                $update = NotificacionesUsuario::where("id_user", $request->id_user)->update([ "token" => $request->token_uid ]);
                if($update){
                    $response["estatus"] = true;
                    $response["mensaje"] = "El token se actualizó correctamente";  
                }else{
                    $response["mensaje"] = "Error al actualizar token";    
                }

            }else{

                $notificacion_new = new NotificacionesUsuario();
                $notificacion_new->id_user = $request->id_user;
                $notificacion_new->token   = $request->token_uid;
                
                if($notificacion_new->save()){
                    $response["estatus"] = true;
                    $response["mensaje"] = "El token se registró correctamente";  
                }else{
                    $response["mensaje"] = "Error al añadir token";   
                }
                

            }
        }else{
            $response["mensaje"] = "El usuario no existe";   
        }

        return response()->json($response, 200);

    }

    // public function view_comunicado( Request $request ){

    //     $response["estatus"] = false;

    //     $validator = \Validator::make($request->all(),
    //         [
    //             'id' => 'required|numeric',
    //         ]
    //     );

    //     $comunicado = Comunicados::find( $request->id );

    //     if( $comunicado ){
    //         $comunicado->visto = 1;            

    //         if( $comunicado->save() ){
    //             $response["estatus"] = true;
    //             $response["mensaje"] = "El comunicado se actualizó correctamente.";
    //         }else{
    //             $response["mensaje"] = "El comunicado no pudo actualizarse.";
    //         }
            
    //     }else{
    //         $response["mensaje"] = "El comunicado no existe";
    //     }

    //     return response()->json($response, 200);

    // }


    public function test()
    {
        $response["test"] = "es un test";
        return response()->json($response, 504);
    }
}