<?php

namespace MetodikaTI\Http\Controllers\Back\Dashboard;

use Illuminate\Http\Request;
use MetodikaTI\Http\Controllers\Controller;
use MetodikaTI\Library\URI;
use MetodikaTI\Horarios;
use MetodikaTI\Vacaciones;
use Auth;

class HorariosController extends Controller
{
    public function index(){
        $user = Auth::user();

        $horario = Horarios::where("id_institucion",$user->id_institucion)->first();

        if( !$horario ){

            $horario_new = new Horarios();

            $horario_new->id_institucion = $user->id_institucion;
            $horario_new->horarios = '[{"inicial":null,"final":null,"dia":"1"},{"inicial":null,"final":null,"dia":"2"},{"inicial":null,"final":null,"dia":"3"},{"inicial":null,"final":null,"dia":"4"},{"inicial":null,"final":null,"dia":"5"},{"inicial":null,"final":null,"dia":"6"},{"inicial":null,"final":null,"dia":"7"}]';
            $horario_new->save();

            $horario = Horarios::where("id_institucion",$user->id_institucion)->first();
            
        }

        return view('back.horarios.index', array( "usuario" => $user, "horario" => $horario, 'permitions' => URI::checkPermitions() ));
    }

    public function save_horario( Request $request ){

        $response["status"] = false;

        $horario = Horarios::where("id_institucion",$request->id_institucion)->first();
        
        //Si existe lo actualiza si no lo crea
        if( $horario ){

            $horario->horarios = json_encode($request->horarios);

            if($horario->save()){
                $response["status"] = true;
                $response["message"] = "El horario se actualizó correctamente";
            }

        }else{
            $horario_new = new Horarios();

            $json = json_encode( $request->horarios );

            $horario_new->horarios       = json_encode( $request->horarios );
            $horario_new->id_institucion = $request->id_institucion;

            if( $horario_new->save() ){
                $response["status"] = true;
                $response["message"] = "El horario se actualizó correctamente";
            }

        }

        return response()->json($response, 200);
    }

    public function activo_inactivo( Request $request ){

        $response["status"] = false;

        $this->validate(
            $request, 
            [   
                'id_institucion' => 'required',                                                       
            ]
        );

        $horario = Horarios::where("id_institucion",$request->id_institucion)->first();
            
        if( $horario ){
            
            if( $request->tipo == "fuera_horario_activo" ){

                $horario->fuera_horario_activo = $request->state;

                if( $horario->save() ){
                    $response["status"]  = true;
                                        
                    if( $request->state == false ){
                        $response["message"] = "El mensaje fuera de horario se desactivo correctamente.";
                    }else{
                        $response["message"] = "El mensaje fuera de horario se activo correctamente.";
                    }
                }

            }

            if( $request->tipo == "inicial_fuera_horario_activo" ){

                $horario->inicial_fuera_horario_activo = $request->state;

                if( $horario->save() ){
                    $response["status"]  = true;
                                        
                    if( $request->state == false ){
                        $response["message"] = "El mensaje inicial se desactivo correctamente.";
                    }else{
                        $response["message"] = "El mensaje inicial se activo correctamente.";
                    }
                }

            }

            if( $request->tipo == "vacaciones_reporte_activo" ){

                $horario->vacaciones_reporte_activo = $request->state;

                if( $horario->save() ){
                    $response["status"]  = true;
                                        
                    if( $request->state == false ){
                        $response["message"] = "El mensaje modo de vacaciones se desactivo correctamente.";
                    }else{
                        $response["message"] = "El mensaje modo de vacaciones se activo correctamente.";
                    }
                }

            }

            if( $request->tipo == "vacaciones_inicial_activo" ){

                $horario->vacaciones_inicial_activo = $request->state;

                if( $horario->save() ){
                    $response["status"]  = true;
                                        
                    if( $request->state == false ){
                        $response["message"] = "El mensaje inicial modo de vacaciones se desactivo correctamente.";
                    }else{
                        $response["message"] = "El mensaje inicial modo de vacaciones se activo correctamente.";
                    }
                }

            }                    

        }else{
            $response["message"] = "Ingresa un horario para activar o desactivar algún mensaje";
        }

        return response()->json($response, 200);
    }

    public function update_mensajes( Request $request ){

        $response["status"] = false;

        $this->validate(
            $request, 
            [   
                'id_institucion' => 'required',
                'mensaje'        => 'required',                                                                                                              
            ]
        );

        $horario = Horarios::where("id_institucion",$request->id_institucion)->first();

        if( $horario ){

            if( $request->tipo == "msj_fuera_horario" ){

                $horario->msj_fuera_horario = $request->mensaje;

                if( $horario->save() ){
                    
                    $response["status"]  = true;
                    $response["message"] = "El mensaje fuera de horario se actualizó correctamente";
                    
                }else{
                    $response["message"] = "¡Uy! Algo salió mal. No se pudo actualizar el mensaje.";
                }

            }

            if( $request->tipo == "msj_inicial" ){

                $horario->msj_inicial = $request->mensaje;

                if( $horario->save() ){
                    
                    $response["status"]  = true;
                    $response["message"] = "El mensaje inicial se actualizó correctamente";
                    
                }else{
                    $response["message"] = "¡Uy! Algo salió mal. No se pudo actualizar el mensaje.";
                }

            }

            if( $request->tipo == "msj_vacaciones" ){

                $horario->msj_vacaciones = $request->mensaje;

                if( $horario->save() ){
                    
                    $response["status"]  = true;
                    $response["message"] = "El mensaje de vacaciones se actualizó correctamente";
                    
                }else{
                    $response["message"] = "¡Uy! Algo salió mal. No se pudo actualizar el mensaje.";
                }

            }

            if( $request->tipo == "msj_vacaciones_inicial" ){

                $horario->msj_vacaciones_inicial = $request->mensaje;

                if( $horario->save() ){
                    
                    $response["status"]  = true;
                    $response["message"] = "El mensaje inicial de vacaciones se actualizó correctamente";
                    
                }else{
                    $response["message"] = "¡Uy! Algo salió mal. No se pudo actualizar el mensaje.";
                }

            }

        }else{
            $response["message"] = "Ingresa un horario para mostrar los mensaje";
        }
        
        return response()->json($response, 200);
    }   

    public function get_vacaciones( Request $request ){

        // $response["status"] = false;

        $user = Auth::user();
        $vacaciones = Vacaciones::where("id_institucion", $user->id_institucion)->orderBy("id", "DESC")->get();

        $response["vacaciones"] = $vacaciones;

        return response()->json($response, 200);

    }

    public function add_vacaciones( Request $request ){

        $response["status"] = false;

        $user = Auth::user();
        
        $vacaciones = new Vacaciones();

        $vacaciones->fecha_inicial  = $request->fecha_inicial;
        $vacaciones->fecha_final    = $request->fecha_final;
        $vacaciones->id_institucion = $user->id_institucion;

        if( $vacaciones->save() ){
            $response["status"] = true;
            $response["message"] = "Las vacaciones se añadieron correctamente";
        }else{
            $response["message"] = "¡Uy! Algo salió mal. No se pudieron añadir las vacaciones.";
        }

        return response()->json($response, 200);

    }

    public function eliminar_vacaciones( Request $request ){

        $response["status"] = false;

        $this->validate(
            $request, 
            [   
                'id_institucion' => 'required',  
                'id' => 'required',                                                                                                                         
            ]
        );

        $vacaciones = Vacaciones::where( "id_institucion", $request->id_institucion )->where("id", $request->id)->delete();

        if( $vacaciones ){
            $response["status"] = true;
            $response["message"] = "El registro se eliminó correctamente";
        }else{
            $response["message"] = "¡Uy! Algo salió mal. No se pudieron eliminar el registro.";
        }

        return response()->json($response, 200);

    }

    public function get_horario( Request $request ){
    

        $horario = Horarios::where("id_institucion", $request->id_institucion)->first();

        $response["horario"] = $horario;

        return response()->json($response, 200);

    }

}
