<?php

namespace MetodikaTI\Http\Controllers\Back\Dashboard;

use Illuminate\Http\Request;
use MetodikaTI\Http\Controllers\Controller;
use MetodikaTI\Incidentes;
use MetodikaTI\Institution;
use MetodikaTI\Estados;
use MetodikaTI\Municipios;
use MetodikaTI\Codigos;
use MetodikaTI\UsersApp;
use MetodikaTI\User;

use Auth;

class ReportesController extends Controller
{
    
    public function index(){
        return view('back.reportes.index', array());
    }

    public function reporte_estatus(){

        $user = Auth::user();
        //perfil 2 es un admin
        $institucion = [];
        $usuarios = [];
        if( $user->user_profile_id == 2 ){
            //se consulta de todas las instituciones
            $institucion = Institution::get();
            $tipo = true;
        }else{        
            $tipo = false;
        }        

        return view('back.reportes.estatus', array( "institucion" => $institucion, "tipo" => $tipo ));
    }

    public function reporte_categoria(){
        $categorias = array( array("num" => 1, "name" => "Bullyng"), array("num" => 2, "name" => "Ciberbullying"),
                             array("num" => 3, "name" => "Violencia"), array("num" => 4, "name" => "Vandalismo"),
                             array("num" => 5, "name" => "Actos inapropiados"), array("num" => 6, "name" => "Abuso de poder"),
                             array("num" => 7, "name" => "Acoso / Abuso sexual"), array("num" => 8, "name" => "Exclusión"),
                             array("num" => 9, "name" => "Distribución de material no autorizado"), array("num" => 10, "name" => "Robo") 
                            );

        $user = Auth::user();
        //perfil 2 es un admin
        $institucion = [];
        $usuarios = [];
        if( $user->user_profile_id == 2 ){
            //se consulta de todas las instituciones
            $institucion = Institution::get();
            $tipo = true;
        }else{        
            $tipo = false;
        }        

        return view('back.reportes.categorias', array( "categorias" => $categorias, "institucion" => $institucion, "tipo" => $tipo ));
    }

    public function consulta_reporte_categoria( Request $request ){
        $response["status"] = false;
        
        $this->validate(
            $request, 
            [                   
                'categoria' => 'required',
                'date_1'    => 'required',
                'date_1'    => 'required'                                         
            ],
            [                   
                'categoria.required' => 'La categoria es requerida.',                   
                'date_1.required' => 'La fecha inicial es requerida.',
                'date_1.required' => 'La fecha final es requerida.',                   
            ]
        );

        if( date($request->date_1) >= date($request->date_2) ){
            $response["message"] = "La fecha inicial debe ser menor a la fecha final.";
            return response()->json($response, 200);
        }

        $organizacion = $request->org;

        $user = Auth::user();
        if( $user->user_profile_id > 2 ){
            $organizacion = $user->id_institucion;
        }

        // $incidentes = Incidentes::whereBetween("created_at",[date($request->date_1), date($request->date_2)])->get();

        
        //TODAS LAS ORGANIZACIONES
        if( $organizacion == 0 ){
            
            $incidentes = Incidentes::select('incidentes.id','incidentes.created_at', 'institutions.name','institutions.sector', 'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                      ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                      ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])->get();

                                      
            if( $request->categoria ==0 ){                
                $inc_abierto     = Incidentes::where("estatus", 1)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_seguimiento = Incidentes::where("estatus", 2)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_cerrado     = Incidentes::where("estatus", 3)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();            
            }else{                

                $inc_abierto     = Incidentes::where("estatus", 1)->where("categoria", $request->categoria)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_seguimiento = Incidentes::where("estatus", 2)->where("categoria", $request->categoria)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_cerrado     = Incidentes::where("estatus", 3)->where("categoria", $request->categoria)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();            
            }

            $response["status"] = true;

        }else{

            if( $request->categoria ==0 ){
                
                $incidentes = Incidentes::select('incidentes.id','incidentes.created_at', 'institutions.name','institutions.sector', 'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                      ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                      ->where("incidentes.id_institucion", $organizacion)
                                      ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])->get();

                $inc_abierto     = Incidentes::where("id_institucion", $organizacion)->where("estatus", 1)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_seguimiento = Incidentes::where("id_institucion", $organizacion)->where("estatus", 2)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_cerrado     = Incidentes::where("id_institucion", $organizacion)->where("estatus", 3)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                
            }else{

                $incidentes = Incidentes::select('incidentes.id_institucion','incidentes.id','incidentes.created_at', 
                                                 'institutions.name','institutions.sector', 'incidentes.estatus', 'incidentes.categoria', 
                                                 'incidentes.codigo')
                                        ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                        ->where("incidentes.id_institucion", $organizacion)
                                        ->where("incidentes.categoria", $request->categoria)
                                        ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])->get();

                $inc_abierto     = Incidentes::where("id_institucion", $organizacion)->where("estatus", 1)->where("categoria", $request->categoria)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_seguimiento = Incidentes::where("id_institucion", $organizacion)->where("estatus", 2)->where("categoria", $request->categoria)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_cerrado     = Incidentes::where("id_institucion", $organizacion)->where("estatus", 3)->where("categoria", $request->categoria)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
            }

            $response["status"] = true;

        }
        

        if( count($incidentes) == 0 ){
            $response["status"]  = false;
            $response["message"] = "No se encontrarón incidentes.";
            return response()->json($response, 200);
        }

        // $incidentes = Incidentes::select('incidentes.id_institucion','incidentes.estatus', 'incidentes.codigo', 'incidentes.created_at', 'institutions.name', 'institutions.logo')
        //                     ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
        //                     ->join('institutions', 'incidentes.id_institucion', '=', 'institutions.id')
        //                     ->get();

        $response["incidentes"] = $incidentes;

        $response["abierto"]     = $inc_abierto;
        $response["seguimiento"] = $inc_seguimiento;
        $response["cerrado"]     = $inc_cerrado;

        return response()->json($response, 200);
    }

    public function consulta_reporte_estatus( Request $request ){

        $response["status"] = false;
        
        $this->validate(
            $request, 
            [   
                // 'org' => 'required',
                // 'estatus'   => 'required', 
                'estatus' => 'required',
                'date_1'    => 'required',
                'date_1'    => 'required'                                         
            ],
            [   
                'org.required' => 'La organización es requerida.',
                // 'estatus.required'   => 'El estatus es requerido.', 
                'estatus.required' => 'El estatus es requerido.',                   
                'date_1.required' => 'La fecha inicial es requerida.',
                'date_1.required' => 'La fecha final es requerida.',                   
            ]
        );

        if( date($request->date_1) >= date($request->date_2) ){
            $response["message"] = "La fecha inicial debe ser menor a la fecha final.";
            return response()->json($response, 200);
        }

        $user = Auth::user();
     
        if( $user->user_profile_id == 2 ){
            
            //TODAS LAS ORGANIZACIONES
            if( $request->org == 0 ){

                if( $request->estatus == 0 ){

                    $incidentes = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                                        'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                                    ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                                    // ->where("incidentes.estatus", $request->estatus)
                                                    ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                                    ->get();  

                }else{

                    $incidentes = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                                        'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                                    ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                                    ->where("incidentes.estatus", $request->estatus)
                                                    ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                                    ->get();                
                }
                

                // $incidentes = Incidentes::where("estatus", $request->estatus)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->get();                
            }else{
                // $incidentes = Incidentes::where("estatus", $request->estatus)->where("id_institucion", $request->org)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->get();            
                
                if( $request->estatus == 0 ){

                    $incidentes = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                                        'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                                    ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                                    // ->where("incidentes.estatus", $request->estatus)
                                                    ->where("id_institucion", $request->org)
                                                    ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                                    ->get();

                    error_log( "TODOSSS" );                                                    

                }else{

                    $incidentes = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                                        'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                                    ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                                    ->where("incidentes.estatus", $request->estatus)
                                                    ->where("id_institucion", $request->org)
                                                    ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                                    ->get();    
                }

            }

        }else{        
            
            if( $request->estatus == 0 ){

                $incidentes = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                                        'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                                    ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                                    // ->where("incidentes.estatus", $request->estatus)
                                                    ->where("id_institucion", $user->id_institucion)
                                                    ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                                    ->get();    

            }else{

                $incidentes = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                                        'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                                    ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                                    ->where("incidentes.estatus", $request->estatus)
                                                    ->where("id_institucion", $user->id_institucion)
                                                    ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                                    ->get();    
            }


        }

        // $incidentes = Incidentes::whereBetween("created_at",[date($request->date_1), date($request->date_2)])->get();

        

        $response["status"] = true;

        if( count($incidentes) == 0 ){
            $response["status"]  = false;
            $response["message"] = "No se encontrarón incidentes.";
            return response()->json($response, 200);
        }

        $response["incidentes"] = $incidentes;

        return response()->json($response, 200);

    }

    public function consulta_reporte_ubicacion( Request $request ){

        $response["status"] = false;
        
        $this->validate(
            $request, 
            [   
                'estados' => 'required',
                // 'estatus'   => 'required',                 
                'date_1'    => 'required',
                'date_1'    => 'required'                                         
            ],
            [   
                'estados.required' => 'El estado es requerido.',                                              
                'date_1.required' => 'La fecha inicial es requerida.',
                'date_1.required' => 'La fecha final es requerida.',                   
            ]
        );

        if( date($request->date_1) >= date($request->date_2) ){
            $response["message"] = "La fecha inicial debe ser menor a la fecha final.";
            return response()->json($response, 200);
        }

        if( $request->municipios == 0 ){
            $instituciones = Institution::where( "state", $request->estados )->pluck("id")->toArray(); 
            
            $abierto  = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                            'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                            ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                            ->whereIn( "incidentes.id_institucion", $instituciones )
                                            ->where("incidentes.estatus",1)
                                            ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                            ->count();

            $seguimiento  = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                            'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                            ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                            ->whereIn( "incidentes.id_institucion", $instituciones )
                                            ->where("incidentes.estatus",2)
                                            ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                            ->count();

            $cerrado  = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                            'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                            ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                            ->whereIn( "incidentes.id_institucion", $instituciones )
                                            ->where("incidentes.estatus",3)
                                            ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                            ->count();
                    
        }else{
            
            $instituciones = Institution::where( "state", $request->estados )->where( "city", $request->municipios )->pluck("id")->toArray();;

            $abierto  = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                                'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                            ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                            ->whereIn( "incidentes.id_institucion", $instituciones )
                                            ->where("incidentes.estatus",1)->where( "city", $request->municipios )
                                            ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                            ->count();

            $seguimiento  = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                            'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                            ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                            ->whereIn( "incidentes.id_institucion", $instituciones )
                                            ->where("incidentes.estatus",2)->where( "city", $request->municipios )
                                            ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                            ->count();

            $cerrado  = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                            'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                            ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                            ->whereIn( "incidentes.id_institucion", $instituciones )
                                            ->where("incidentes.estatus",3)->where( "city", $request->municipios )
                                            ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                            ->count();
        }

        $incidentes    = Incidentes::select('incidentes.id', 'institutions.name','institutions.sector', 'incidentes.created_at', 
                                            'incidentes.estatus', 'incidentes.categoria', 'incidentes.codigo')
                                            ->join("institutions", "institutions.id","=","incidentes.id_institucion")
                                            ->whereIn( "incidentes.id_institucion", $instituciones )
                                            ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                            ->get();

        $response["status"] = true;
        $response["incidentes"]  = $incidentes;
        $response["abierto"]     = $abierto;
        $response["seguimiento"] = $seguimiento;
        $response["cerrado"]     = $cerrado;

        return response()->json($response, 200);
    }
    


    public function reporte_ubicacion(){
        $estados = Estados::get();
        return view('back.reportes.ubicacion', array( "estados" => $estados ));
    }

    public function municipios( Request $request ){
        $response["status"] = false;

        $municipios = Municipios::where("estado", $request->clave)->get();

        return response()->json($response, 200);
    }

    public function usuario(){
        $user = Auth::user();
        //perfil 2 es un admin
        $instituciones = [];
        $usuarios = [];
        if( $user->user_profile_id == 2 ){
            //se consulta de todas las instituciones
            $instituciones = Institution::get();
            $tipo = true;
        }else{
            //es otro tipo de usuario
            //solo de la insitucion a la que pertenece
            
            $usuarios = User::where( "id_institucion", $user->id_institucion )->get();
            $tipo = false;
        }


        return view('back.reportes.usuario', array( "instituciones" => $instituciones,"tipo" => $tipo, "usuarios" => $usuarios ));
    }

    public function usuarios_institucion( Request $request ){

        // $response["status"] = false;

        $this->validate(
            $request, 
            [   
                'institucion' => 'required',                                                  
            ],
            [   
                'institucion.required' => 'La institución es requerida.',                                                                   
            ]
        );
                
        $usuarios = User::where("id_institucion",$request->institucion)->get();

        $response["usuarios"] = $usuarios;

        return response()->json($response, 200);
        // $usuariosApp = UsersApps::where()

    }

    public function consulta_usuarios( Request $request ){

        $response["status"] = false;

        $this->validate(
            $request, 
            [   
                'usuario' => 'required',  
                'date_1'  => 'required',
                'date_1'  => 'required'                                                  
            ],
            [   
                'usuario.required' => 'El usuario es requerido.',  
                'date_1.required' => 'La fecha inicial es requerida.',
                'date_1.required' => 'La fecha final es requerida.',                                                                   
            ]
        );  
        
        if( date($request->date_1) >= date($request->date_2) ){
            $response["message"] = "La fecha inicial debe ser menor a la fecha final.";
            return response()->json($response, 200);
        }                 

        $user = Auth::user();
        
        if( !empty($request->instituciones) ){
            error_log("usuario ".$request->usuario);
            if( $request->usuario == "0" ){
                
                $response["message"] = "Ingresa un usuario para tu reporte.";
                return response()->json($response, 200);
            }
            
        }
        
        $response["status"] = true;   
        if( $user->user_profile_id == 2 ){           
           
                $inc_abierto     = Incidentes::where("id_institucion", $request->instituciones)->where("asignado", $request->usuario)->where("estatus", 1)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_seguimiento = Incidentes::where("id_institucion", $request->instituciones)->where("asignado", $request->usuario)->where("estatus", 2)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_cerrado     = Incidentes::where("id_institucion", $request->instituciones)->where("asignado", $request->usuario)->where("estatus", 3)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();            

                $incidentes = Incidentes::where("id_institucion", $request->instituciones)->where("asignado", $request->usuario)
                                        ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                        ->get();
                

            $tipo = true;
        }else{
            
            if( $request->usuario == 0 ){
                $incidentes = Incidentes::where("id_institucion", $user->id_institucion)
                                        ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                        ->get();

                $inc_abierto     = Incidentes::where("id_institucion", $user->id_institucion)->where("estatus", 1)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_seguimiento = Incidentes::where("id_institucion", $user->id_institucion)->where("estatus", 2)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_cerrado     = Incidentes::where("id_institucion", $user->id_institucion)->where("estatus", 3)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();            
                
            }else{

                $inc_abierto     = Incidentes::where("id_institucion", $user->id_institucion)->where("asignado", $request->usuario)->where("estatus", 1)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_seguimiento = Incidentes::where("id_institucion", $user->id_institucion)->where("asignado", $request->usuario)->where("estatus", 2)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();
                $inc_cerrado     = Incidentes::where("id_institucion", $user->id_institucion)->where("asignado", $request->usuario)->where("estatus", 3)->whereBetween("created_at",[date($request->date_1), date($request->date_2)])->count();            

                $incidentes = Incidentes::where("id_institucion", $user->id_institucion)->where("asignado", $request->usuario)
                                        ->whereBetween("incidentes.created_at",[date($request->date_1), date($request->date_2)])
                                        ->get();
            }
            
            // $tipo = false;
        }

        if( count($incidentes) == 0 ){
            $response["status"]  = false;
            $response["message"] = "No se encontrarón incidentes.";
            return response()->json($response, 200);
        }
        
        $response["abierto"]     = $inc_abierto;
        $response["seguimiento"] = $inc_seguimiento;
        $response["cerrado"]     = $inc_cerrado;
        $response["incidentes"]  = $incidentes;

        return response()->json($response, 200);

    }

}
