@extends('back.layout.dashboard')

@section('contentTitle', 'Editar institución')

@section('topButton')
    <a href="{{ route('instituciones') }}" class="m-l-15"><button type="button" class="btn btn-info d-none d-lg-block"><i class="fas fa-chevron-left"></i> Regresar</button></a>
@stop

@section('CSS')
    
    <style>
        .head{
            font-weight: bold;
            font-size: 14px;
            padding-top: 20px;
            padding-bottom: 10px;
        }
    </style>

@endsection

@section('content_dashboard')

    <div class="row">
        <div class="col-sm-12">
            <div class="card card-body">

                {{ Form::open(['route' => array( 'update_institucion', base64_encode($institucion->id) ), 'class' => 'form-horizontal']) }}

                    <div class="row">

                        <div class="col-lg-6">
                            
                            <div class="form-group">
                                <label>Nombre de la institución</label>
                                {{ Form::text('nombre', $institucion->name, ['class' => 'form-control', "placeholder" => "Nombre de la institución"]) }}
                            </div>
    
                            <div class="form-group">
                                <label>Logo</label>
                                <input type="file" class="form-control" name="logo">
                                {{-- {{ Form::text('nombre', null, ['class' => 'form-control', "placeholder" => "Nombre de la institución"]) }} --}}
                            </div>
    
                            <div class="form-group">
                                <label>Teléfono</label>
                                <input type="text" value="{{ $institucion->phone }}" name="telefono" maxlength="10" placeholder="Teléfono" class="form-control">
                            </div>
    
                            <div class="form-group">
                                <label>Dirección</label>
                                <input type="text" value="{{ $institucion->direction }}" name="direccion" maxlength="100" placeholder="Direccón" class="form-control">
                            </div>
    
                            <div class="form-group">
                                <label>Contacto informativo</label>
                                <input type="text"  value="{{ $institucion->contact }}" name="contacto_informativo" maxlength="100" placeholder="Contacto informativo" class="form-control">
                            </div>
    
                            <div class="form-group">
                                <label>Correo de contacto informativo</label>
                                <input type="email"  value="{{ $institucion->email_contact }}" name="email_contacto_info" maxlength="50" placeholder="Correo de contacto informativo" class="form-control">
                            </div>
    
                            {{-- <p class="head">Usuario master de plataforma</p>
    
                            <div class="form-group">
                                <label>Nombre</label>
                                <input type="text" name="nombre_master" maxlength="100" placeholder="Nombre" class="form-control">
                            </div>
    
                            <div class="form-group">
                                <label>Puesto</label>
                                <input type="text" name="puesto" maxlength="100" placeholder="Puesto" class="form-control">
                            </div>
    
                            <div class="form-group">
                                <label>Teléfono personal</label>
                                <input type="text" name="telefono_master" maxlength="100" placeholder="Teléfono personal" class="form-control">
                            </div> --}}
    
                            {{-- <p class="head">Correo y contraseña serán sus accesos para ingresar a la plataforma</p>
                            
                            <div class="form-group">
                                <label>Correo</label>
                                <input type="text" name="email_master" maxlength="100" placeholder="Correo electrónico" class="form-control">
                            </div>
    
                            <div class="form-group">
                                <label>Contraseña</label>
                                <input type="password" name="pass" maxlength="100" placeholder="******" class="form-control">
                            </div>
    
                            <div class="form-group">
                                <label>Confirmar Contraseña</label>
                                <input type="password" name="confirm_pass" maxlength="100" placeholder="******" class="form-control">
                            </div> --}}
    
                        </div>

                        <div class="col-lg-6 col-md-6">
                            
                            <div class="form-group">
                                <label>Estatus</label>
                                <select class="form-control" name="estatus">
                                    <option></option>           
                                    @if( $institucion->estatus == 1 )
                                        <option selected value="1">Activo</option>
                                    @else
                                        <option value="1">Activo</option>
                                    @endif   

                                    @if( $institucion->estatus == 0 )
                                        <option selected value="0">Inactivo</option>
                                    @else
                                        <option value="0">Inactivo</option>
                                    @endif 
                                    
                                    @if( $institucion->estatus == 2 )
                                        <option selected value="2">Prueba</option>
                                    @else
                                        <option value="2">Prueba</option>
                                    @endif   
                                                                                                            
                                </select>
                            </div>

                            <div class="form-group">
                                <label>Estado</label>
                                
                                <select class="form-control" name="estado" id="estados">                                    
                                   
                                </select>
                            </div>

                            <div class="form-group">
                                <label>Municipios</label>
                                <select class="form-control" name="municipio" id="municipios">
                                    <option></option>

                                </select>
                            </div>

                            <div class="form-group">
                                <label>Sector</label>
                                <select class="form-control" name="sector" id="sector">
                                    <option></option>
                                    @if( $institucion->sector == 0 )
                                        <option selected value="0">Publico</option>
                                    @else
                                        <option value="0">Publico</option> 
                                    @endif

                                    @if( $institucion->sector == 1 )
                                        <option selected value="1">Privado</option>
                                    @else
                                        <option value="1">Privado</option>
                                    @endif
                                </select>
                            </div>
    
                        </div>

                    </div>
 
                    <button type="submit" class="btn btn-info">Guardar</button>

                {{ Form::close() }}

            </div>
        </div>
    </div>

@stop

@section('JS')
    {{ Html::script('system/js/form.js')  }}
    <script>

        var insiticion = {!! json_encode($institucion) !!};
        console.log( "insiticion", insiticion );

        loadEstados();

        function loadEstados(){

            $("#estados").empty();
            $("#estados").append( "<option></option>" );
            $.ajax({
                url: '{{ route("estados") }}',
                type: "POST",
                data: {},
                error: function (e) {
                    console.log("Error",e);
                    if( e ){

                    }
                },      
                success: function (response) {                    
                    for( var estado of response.estados ){
                        if( estado.clave == insiticion.state ){
                            $("#estados").append( "<option selected value='"+estado.clave+"'>"+ estado.nombre +"</option>" );
                            loadMunicipios(estado.clave);
                        }else{
                            $("#estados").append( "<option value='"+estado.clave+"'>"+ estado.nombre +"</option>" );
                        }
                    }
                                
                }

            });   

        }
        

        $("#estados").change(function(){
            var valor = $( this ).val();            
            loadMunicipios(valor);

        });

        function loadMunicipios( id ){

            $("#municipios").empty();

            $.ajax({
                url: '{{ route("municipios") }}',
                type: "POST",
                data: { clave_estado: id },
                error: function (e) {
                    console.log("Error",e);
                    if( e ){

                    }
                },      
                success: function (response) {
                    console.log("municipios",response);

                    for( var municipio of response.municipios ){
                        console.log(municipio.nombre, insiticion.city);
                        if( municipio.id == insiticion.city ){
                            $("#municipios").append( "<option selected value='"+municipio.id+"'>"+ municipio.nombre +"</option>" );
                        }else{
                            $("#municipios").append( "<option value='"+municipio.clave+"'>"+ municipio.nombre +"</option>" );
                        }
                    }
                                
                }

            });   
        }        
        

    </script>
@stop