@extends('back.layout.dashboard')

@section('contentTitle', 'Instituciones')

@section('topButton')
    @if( $permitions["create"] )
    {{-- {{ route('nueva_institucion') }} --}}
        <a href="{{ route('nueva_institucion') }}" class="m-l-15">
            <button type="button" class="btn btn-info d-none d-lg-block">
                <i class="fa fa-plus-circle"></i>Nueva institución
            </button>
        </a>
    @endif
@stop


{{-- Main Content --}}
@section('content_dashboard')

    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-body">
                    <div class="table-responsive">
                        <table id="table_principal" class="display nowrap table table-hover table-striped table-bordered" cellspacing="0" width="100%">
                            <thead>
                            <tr>
                                <th>ID</th>
                                <th>Institución</th>
                                <th>Fecha de alta</th>
                                <th>Fecha fin</th>
                                <th>Estatus</th>
                                <th>Usuarios en app</th>
                                <th>Acciones</th>
                            </tr>
                            </thead>
                            <tbody>
                                @foreach($data_institucion as $item)
                                    <tr>
                                        <td>{{ $item["id"] }}</td>
                                        <td>{{ $item["name"]  }}</td>
                                        <td>{{ $item["created_at"]  }}</td>
                                        <td></td>
                                        <td>                                            
                                            @if( $item["estatus"] == 0 )
                                                Inactivo
                                            @endif

                                            @if( $item["estatus"] == 1 )
                                                Activo
                                            @endif

                                            @if( $item["estatus"] == 2 )
                                                Prueba
                                            @endif
                                            {{-- {{ $item->status }} --}}
                                        </td>
                                        <td>{{ $item["num_users"] }}</td>
                                        
                                        <td>
                                            @if( $permitions["edit"] )
                                                <a href="{{ route('editar_institucion', base64_encode( $item['id'] )) }}">
                                                    <button type="button" class="btn btn-sm waves-effect waves-light btn-success"><i class="fas fa-edit"></i> Editar</button>
                                                </a>
                                            @endif
                                            @if( $permitions["delete"] )
                                                <a href="{{ route('delete_institucion',  base64_encode($item['id'])) }}" class="btn-delete">
                                                    <button type="button" class="btn btn-sm waves-effect waves-light btn-danger">
                                                        <i class="fas fa-minus-circle"></i> Eliminar
                                                    </button>
                                                </a>
                                            @endif
                                            
                                            @if( $item['estatus'] == 0 )
                                            {{-- {{ route('activar_institucion',  base64_encode($item->id)) }} --}}
                                                <a href="javascript:0;" onclick="estatus({{ $item['id'] }}, 1,'{{ $item['name']}}')" class="activar-{{$item['id']}}">
                                                    <button type="button" class="btn btn-sm waves-effect waves-light btn-info">
                                                        <i class="fas fa-minus-circle"></i> Activar
                                                    </button>
                                                </a>
                                            @endif
                                            
                                            @if( $item['estatus'] == 1 )
                                            {{-- {{ route('activar_institucion',  base64_encode($item->id)) }} --}}
                                                <a href="javascript:0;" onclick="estatus({{ $item['id'] }}, 0, '{{  $item['name'] }}')" class="desactivar-{{$item['id']}}">
                                                    <button type="button" class="btn btn-sm waves-effect waves-light btn-warning">
                                                        <i class="fas fa-minus-circle"></i> Inactivo
                                                    </button>
                                                </a>
                                            
                                            @endif
                                            
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>

@stop

{{-- Page JS --}}
@section('JS')
    {{ Html::script('system/js/table.js')  }}
    {{ Html::script('system/js/form.js')  }}

    <script>
        function estatus( id, status, name ){
            //2 desactivar
            // 1 activar
            console.log(id, status);
            Swal.fire({
                title: '¿Estás seguro?',
                text: "Deseas cambiar el estatus de la institución: " + name,
                icon: 'error',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'SI',
                cancelButtonText:'NO'
                }).then((result) => {
                    
                    if (result.value) {
                        $.ajax({
                            url: '{{ route("activar_institucion") }}',
                            type: "POST",
                            data: { id: id, status:status },
                            error: function (e) {

                            },  
                            success: function (response) {

                                if( response.status ){
                                   
                                    Swal.fire(
                                        'Estatus!',
                                        response.message,
                                        'success'
                                    );

                                    setTimeout(function(){
                                        location.reload();
                                    }, 1000);

                                }else{
                                    Swal.fire(
                                        'Estatus!',
                                        response.message,
                                        'danger'
                                    );
                                }
                            }                         
                        });
                    }

                });
        }
    </script>
@stop
