@extends('back.layout.dashboard')

@section('contentTitle', 'Editar institución')

@section('topButton')
    <a href="{{ route('codigos') }}" class="m-l-15"><button type="button" class="btn btn-info d-none d-lg-block"><i class="fas fa-chevron-left"></i> Regresar</button></a>
@stop

@section('CSS')
    
    <style>
        .head{
            font-weight: bold;
            font-size: 14px;
            padding-top: 20px;
            padding-bottom: 10px;
        }
    </style>

@endsection

@section('content_dashboard')

    <div class="row">
        <div class="col-sm-12">
            <div class="card card-body">

                {{ Form::open(['route' => array( 'update_codigo', base64_encode($codigo->id) ), 'class' => 'form-horizontal']) }}

                    <div class="row">
                        <div class="col-lg-4">

                            <div class="form-group">
                                <label for="">Código</label>
                                <input type="text" maxlength="20" id="codigo" value="{{$codigo->codigo}}" name="codigo" class="form-control" placeholder="Ingresa un código alfanumérico">
                                
                                <div style="display: none; margin-top:10px;" id="disponible">
                                    <p class="text-info">Código disponible</p>
                                </div>
                                
                            </div>


                        </div>

                        <div class="col-lg-4">

                            <div class="form-group">
                                <label for="">Asignación de código</label>
                                <input type="text" maxlength="50" id="tag" value="{{ $codigo->name }}" name="name" class="form-control" placeholder="Primaria menor">
                                {{-- <select class="form-control" name="" id="instituciones">
                                    <option value=""></option>
                                </select> --}}
                            </div>

                        </div>
                    </div>
 
                    <button type="submit" class="btn btn-info">Guardar</button>

                {{ Form::close() }}

            </div>
        </div>
    </div>

@stop

@section('JS')
    {{ Html::script('system/js/form.js')  }}    

    <script>

        var typingTimer;                //timer identifier
        var doneTypingInterval = 1000;
        var codigo;
        var codigo_edit = {!! json_encode($codigo) !!}

        $("#codigo").keyup(function(){
            var val = $(this).val();
            codigo = val;
            clearTimeout(typingTimer);
            if (val) {            
                typingTimer = setTimeout(function(){
                    // var valoresAceptados = /^[0-9]+$/;
                    // $("#disponible").hide(200);
                    // if (!codigo.match(valoresAceptados)){
                    //     swal("Error", "Ingresa solo números!", "error");
                    // }else if( codigo.length < 4 ){
                    //     swal("Error", "Ingresa un codigo de 4 digitos!", "error");
                    // }else{
                        
                        $.ajax({
                            url: '{{ route("search_code_update") }}',
                            type: "POST",
                            data: { code: codigo, id_codigo:codigo_edit.id },
                            error: function (e) {
                                console.log("Error",e);
                                if( e ){

                                }
                            },      
                            success: function (response) {    
                                if( response.status ){
                                    $("#disponible").show(200);
                                    $("#guardar").prop("disabled", false);
                                }else{
                                    $("#disponible").hide(200);
                                    $("#guardar").prop("disabled", true);
                                    swal("Error", response.message, "error");
                                } 
                                console.log( "response ==> ",response );
                            }

                        });
                    // }
                }, 1000);
            }            

        });
    </script>
@stop