<?php

Route::get('test', 'Back\AccountController@test');

Route::get('/', 'Back\AccountController@getHome')->name('login');
Route::get('change_password/{token}', 'Back\AccountController@change_password');
Route::post('update_password/{token}', 'Back\AccountController@update_password')->name("update_password");


Route::group(['prefix' => 'account'], function () {
    Route::get('logout', 'Back\AccountController@getLogout')->name('admin_logout');
    Route::post('login', 'Back\AccountController@postLogin')->name('admin_login');
    Route::post('password/reset', 'Back\AccountController@postReset')->name('password.reset');
});

Route::group(['middleware' => ['auth']], function () {
    
    
    Route::group(['prefix' => 'dashboard'], function () {
        
        
        Route::get('/', 'Back\Dashboard\DashboardController@index');
        
        //INSTITUCIONES
        Route::group(['prefix' => 'instituciones'], function () {
            Route::get('/', 'Back\Dashboard\InstitucionesController@index')->name('instituciones');
            Route::get('/nueva-institucion', 'Back\Dashboard\InstitucionesController@create')->name('nueva_institucion');
            Route::post('/estados', 'Back\Dashboard\InstitucionesController@estados')->name('estados');
            Route::post('/municipios', 'Back\Dashboard\InstitucionesController@municipios')->name('municipios');
            Route::post('/create_institucion', 'Back\Dashboard\InstitucionesController@create_institucion')->name('create_institucion');
            Route::get('/delete_institucion/{id}', 'Back\Dashboard\InstitucionesController@delete_institucion')->name('delete_institucion');            
            Route::get('/editar-institucion/{id}', 'Back\Dashboard\InstitucionesController@editar_institucion')->name('editar_institucion');   
            Route::post('/update-institucion/{id}', 'Back\Dashboard\InstitucionesController@update_institucion')->name('update_institucion');   
            // Route::get('/activar_institucion/{id}', 'Back\Dashboard\InstitucionesController@activar_institucion')->name('activar_institucion');            
            Route::post('/activar_institucion', 'Back\Dashboard\InstitucionesController@activar_institucion')->name('activar_institucion');            
            Route::get('/desactivar_institucion/{id}', 'Back\Dashboard\InstitucionesController@desactivar_institucion')->name('desactivar_institucion');            
            
            // Route::post('/insert_estados', 'Back\Dashboard\InstitucionesController@insert_estados')->name('insert_estados');
        });

        //TELEFONOS
        Route::group(['prefix' => 'telefonos'], function () {
            Route::get('/', 'Back\Dashboard\TelefonosController@index_tel')->name('telefonos');
            Route::get('/nuevo-telefono', 'Back\Dashboard\TelefonosController@nuevo_telefono')->name('nuevo_telefono');
            Route::post('/save-telefono', 'Back\Dashboard\TelefonosController@save_telefono')->name('save_telefono'); 
            Route::get('/editar-telefono/{id}', 'Back\Dashboard\TelefonosController@editar_telefono')->name('editar_telefono'); 
            Route::get('/delete-telefono/{id}', 'Back\Dashboard\TelefonosController@delete_telefono')->name('delete_telefono'); 
            Route::post('/update-telefono/{id}', 'Back\Dashboard\TelefonosController@update_telefono')->name('update_telefono'); 
            Route::post('/update-telefono-new', 'Back\Dashboard\TelefonosController@update_telefono_new')->name('update_telefono_new');                                   
            Route::post('/delete-telefono-new', 'Back\Dashboard\TelefonosController@eliminar_telefono_new')->name('eliminar_telefono_new');            
            Route::post('/update-orden-telefono', 'Back\Dashboard\TelefonosController@update_orden_telefono')->name('update_orden_telefono');                        
        });

        Route::group(['prefix' => 'comunicados'], function () {
            Route::get('/', 'Back\Dashboard\ComunicadosController@index')->name('comunicados');
            Route::get('/nuevo-comunicado', 'Back\Dashboard\ComunicadosController@nuevo_comunicado')->name('nuevo_comunicado');
            Route::get('/editar-comunicado/{id}', 'Back\Dashboard\ComunicadosController@editar_comunicado')->name('editar_comunicado'); 
            Route::get('/delete-comunicado/{id}', 'Back\Dashboard\ComunicadosController@delete_comunicado')->name('delete_comunicado');
            Route::post('/save-comunicado', 'Back\Dashboard\ComunicadosController@save_comunicado')->name('save_comunicado'); 
            Route::post('/update-comunicado/{id}', 'Back\Dashboard\ComunicadosController@update_comunicado')->name('update_comunicado');                         
        });


        Route::group(['prefix' => 'codigos'], function () {
            Route::get('/', 'Back\Dashboard\CodigosController@index')->name('codigos');
            Route::get('/config-codigos', 'Back\Dashboard\CodigosController@editar_codigo')->name('editar_codigo');
            Route::post('/search-code', 'Back\Dashboard\CodigosController@search_code')->name('search_code');
            Route::post('/instituciones-code', 'Back\Dashboard\CodigosController@instituciones_code')->name('instituciones_code'); 
            Route::post('/add-code', 'Back\Dashboard\CodigosController@add_code')->name('add_code');   
            Route::get('/editar-codigos/{id}', 'Back\Dashboard\CodigosController@edit_codigo')->name('edit_codigo');  
            Route::get('/delete-codigo/{id}', 'Back\Dashboard\CodigosController@delete_codigo')->name('delete_codigo');  
            Route::post('/update-codigo/{id}', 'Back\Dashboard\CodigosController@update_codigo')->name('update_codigo');
            Route::post('/search-code-update', 'Back\Dashboard\CodigosController@search_code_update')->name('search_code_update');
            
        });


        Route::group(['prefix' => 'incidentes'], function () {
            Route::get('/', 'Back\Dashboard\IncidentesController@index')->name('incidentes');
            Route::get('/incidente/{id}', 'Back\Dashboard\IncidentesController@ver_insidente')->name('ver_incidente');
            Route::get('/tipo/{tipo}', 'Back\Dashboard\IncidentesController@ver_insidentes')->name('ver_incidentes');
            Route::post('/responder/{id}', 'Back\Dashboard\IncidentesController@responder_incidente')->name('responder_incidente');
            Route::post('/chat', 'Back\Dashboard\IncidentesController@chat')->name('chat');
            Route::post('/chat-refresh', 'Back\Dashboard\IncidentesController@chat_refresh')->name('chat_refresh');
            Route::post('/mensajes-vistos', 'Back\Dashboard\IncidentesController@mensaje_visto')->name('mensaje_visto');
            Route::post('/enviar-mensaje', 'Back\Dashboard\IncidentesController@registro_chat')->name('registro_chat');  
            Route::get('/delete-incidente/{id}', 'Back\Dashboard\IncidentesController@delete_incidente')->name('delete_incidente');
            Route::post('/enviar-nota', 'Back\Dashboard\IncidentesController@registro_nota')->name('registro_nota');    
            Route::post('/notas', 'Back\Dashboard\IncidentesController@get_notas')->name('get_notas');         
            Route::post('/update-incidete/{id}', 'Back\Dashboard\IncidentesController@update_incidente')->name('update_incidente');
            Route::post('/update-user-app', 'Back\Dashboard\IncidentesController@update_user_app')->name('update_user_app');                     
        });

        Route::group(['prefix' => 'preguntas'], function () {
            Route::get('/', 'Back\Dashboard\PreguntasController@preguntas')->name('preguntas');
            Route::get('/nueva-pregunta', 'Back\Dashboard\PreguntasController@nueva_pregunta')->name('nueva_pregunta');
            Route::post('/save-pregunta', 'Back\Dashboard\PreguntasController@save_pregunta')->name('save_pregunta');
            Route::get('/editar-codigos/{id}', 'Back\Dashboard\PreguntasController@edit_pregunta')->name('edit_pregunta');  
            Route::post('/update-pregunta/{id}', 'Back\Dashboard\PreguntasController@update_pregunta')->name('update_pregunta');
            Route::get('/delete-pregunta/{id}', 'Back\Dashboard\PreguntasController@delete_pregunta')->name('delete_pregunta'); 
            Route::post('/update-preguntas', 'Back\Dashboard\PreguntasController@update_preguntas')->name('update_preguntas'); 
        });

        //USUARIOS INSTITUCIONES
        Route::get('/usuarios-instituciones', 'Back\Dashboard\UsuariosInstitucionesController@index');

        //HORARIOS
        Route::group(['prefix' => 'horarios'], function () {
            Route::get('/', 'Back\Dashboard\HorariosController@index'); 
            Route::post('/save-horarios', 'Back\Dashboard\HorariosController@save_horario')->name('save_horario');     
            Route::post('/activo-inactivo', 'Back\Dashboard\HorariosController@activo_inactivo')->name('activo_inactivo');   
            Route::post('/update-mensajes', 'Back\Dashboard\HorariosController@update_mensajes')->name('update_mensajes'); 
            Route::post('/horarios', 'Back\Dashboard\HorariosController@get_horario')->name('get_horario');     
            Route::post('/vacaciones', 'Back\Dashboard\HorariosController@get_vacaciones')->name('get_vacaciones');     
            Route::post('/add-vacaciones', 'Back\Dashboard\HorariosController@add_vacaciones')->name('add_vacaciones'); 
            Route::post('/eliminar-vacaciones', 'Back\Dashboard\HorariosController@eliminar_vacaciones')->name('eliminar_vacaciones'); 
                            
        });

        //REPORTES
        Route::group(['prefix' => 'reportes'], function () {
            Route::get('/categoria', 'Back\Dashboard\ReportesController@reporte_categoria');
            Route::get('/estatus', 'Back\Dashboard\ReportesController@reporte_estatus');
            Route::get('/ubicacion', 'Back\Dashboard\ReportesController@reporte_ubicacion');
            Route::post('/reporte-categoria', 'Back\Dashboard\ReportesController@consulta_reporte_categoria')->name("consulta_reporte_categoria");
            Route::post('/reporte-status', 'Back\Dashboard\ReportesController@consulta_reporte_estatus')->name("consulta_reporte_estatus");            
            Route::post('/reporte-ubicacion', 'Back\Dashboard\ReportesController@consulta_reporte_ubicacion')->name("consulta_reporte_ubicacion");                        
            Route::get('/usuario', 'Back\Dashboard\ReportesController@usuario');            
            Route::post('/usuarios-institucion', 'Back\Dashboard\ReportesController@usuarios_institucion')->name("usuarios_institucion");   
            Route::post('/usuarios', 'Back\Dashboard\ReportesController@consulta_usuarios')->name("consulta_usuarios");   
                                 
        });


        Route::group(['prefix' => 'system'], function () {

            Route::group(['prefix' => 'user'], function () {
                Route::get('/', 'Back\Dashboard\System\UserController@index')->name('user_index');
                Route::get('create', 'Back\Dashboard\System\UserController@create')->name('user_create_get');
                Route::post('store', 'Back\Dashboard\System\UserController@store')->name('user_create');
                Route::get('edit/{id}', 'Back\Dashboard\System\UserController@edit')->name('user_edit');
                Route::post('update/{id}', 'Back\Dashboard\System\UserController@update')->name('user_update');
                Route::get('delete/{id}', 'Back\Dashboard\System\UserController@destroy')->name('user_delete');
                Route::get('edit_unique/{id}', 'Back\Dashboard\System\UserController@edit_unique')->name('user_unique_edit');
                Route::post('update_unique/{id}', 'Back\Dashboard\System\UserController@update_unique')->name('user_unique_update');
            });

            Route::group(['prefix' => 'profile'], function () {
                Route::get('/', 'Back\Dashboard\System\ProfileController@index')->name('profile_index');
                Route::get('create', 'Back\Dashboard\System\ProfileController@create')->name('profile_create');
                Route::post('store', 'Back\Dashboard\System\ProfileController@store')->name('profile.store');
                Route::get('edit/{id}', 'Back\Dashboard\System\ProfileController@edit')->name('profile.edit');
                Route::post('update', 'Back\Dashboard\System\ProfileController@update')->name('profile.update');
                Route::get('getData', 'Back\Dashboard\System\ProfileController@getData')->name('profile.data');
                Route::get('view/{id}', 'Back\Dashboard\System\ProfileController@show')->name('profile.view');
                Route::get('delete/{id}', 'Back\Dashboard\System\ProfileController@destroy')->name('profile.delete');
            });

        });


        Route::group(['prefix' => 'catalogos'], function () {

            Route::group(['prefix' => 'colors'], function () {
                Route::get('/', 'Back\Catalog\ColorController@index')->name('colors_index');
                Route::get('create', 'Back\Catalog\ColorController@create')->name('colors_create');
                Route::post('store', 'Back\Catalog\ColorController@store')->name('colors.store');
                Route::get('edit/{id}', 'Back\Catalog\ColorController@edit')->name('colors.edit');
                Route::post('update/{id}', 'Back\Catalog\ColorController@update')->name('colors.update');
                Route::get('delete/{id}', 'Back\Catalog\ColorController@destroy')->name('colors.delete');
            });

        });

        Route::group(['prefix' => 'categorias'], function () {

            Route::get('/', 'Back\Dashboard\CategoriasController@index')->name('categoria_index');
            Route::get('create', 'Back\Dashboard\CategoriasController@create')->name('categoria_create');
            Route::post('store', 'Back\Dashboard\CategoriasController@store')->name('categoria_store');
            Route::get('edit/{id}', 'Back\Dashboard\CategoriasController@edit')->name('editar_categoria');
            Route::post('update/{id}', 'Back\Dashboard\CategoriasController@update')->name('update_categoria');
            Route::get('delete/{id}', 'Back\Dashboard\CategoriasController@destroy')->name('delete_categoria');            

        });

    });


});
