<?php $__env->startSection('contentTitle', 'Editar institución'); ?>

<?php $__env->startSection('topButton'); ?>
    <a href="<?php echo e(route('instituciones')); ?>" class="m-l-15"><button type="button" class="btn btn-info d-none d-lg-block"><i class="fas fa-chevron-left"></i> Regresar</button></a>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('CSS'); ?>
    
    <style>
        .head{
            font-weight: bold;
            font-size: 14px;
            padding-top: 20px;
            padding-bottom: 10px;
        }
    </style>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('content_dashboard'); ?>

    <div class="row">
        <div class="col-sm-12">
            <div class="card card-body">

                <?php echo e(Form::open(['route' => array( 'update_institucion', base64_encode($institucion->id) ), 'class' => 'form-horizontal'])); ?>


                    <div class="row">

                        <div class="col-lg-6">
                            
                            <div class="form-group">
                                <label>Nombre de la institución</label>
                                <?php echo e(Form::text('nombre', $institucion->name, ['class' => 'form-control', "placeholder" => "Nombre de la institución"])); ?>

                            </div>
    
                            <div class="form-group">
                                <label>Logo</label>
                                <input type="file" class="form-control" name="logo">
                                
                            </div>
    
                            <div class="form-group">
                                <label>Teléfono</label>
                                <input type="text" value="<?php echo e($institucion->phone); ?>" name="telefono" maxlength="10" placeholder="Teléfono" class="form-control">
                            </div>
    
                            <div class="form-group">
                                <label>Dirección</label>
                                <input type="text" value="<?php echo e($institucion->direction); ?>" name="direccion" maxlength="100" placeholder="Direccón" class="form-control">
                            </div>
    
                            <div class="form-group">
                                <label>Contacto informativo</label>
                                <input type="text"  value="<?php echo e($institucion->contact); ?>" name="contacto_informativo" maxlength="100" placeholder="Contacto informativo" class="form-control">
                            </div>
    
                            <div class="form-group">
                                <label>Correo de contacto informativo</label>
                                <input type="email"  value="<?php echo e($institucion->email_contact); ?>" name="email_contacto_info" maxlength="50" placeholder="Correo de contacto informativo" class="form-control">
                            </div>
    
                            
    
                            
    
                        </div>

                        <div class="col-lg-6 col-md-6">
                            
                            <div class="form-group">
                                <label>Estatus</label>
                                <select class="form-control" name="estatus">
                                    <option></option>           
                                    <?php if( $institucion->estatus == 1 ): ?>
                                        <option selected value="1">Activo</option>
                                    <?php else: ?>
                                        <option value="1">Activo</option>
                                    <?php endif; ?>   

                                    <?php if( $institucion->estatus == 0 ): ?>
                                        <option selected value="0">Inactivo</option>
                                    <?php else: ?>
                                        <option value="0">Inactivo</option>
                                    <?php endif; ?> 
                                    
                                    <?php if( $institucion->estatus == 2 ): ?>
                                        <option selected value="2">Prueba</option>
                                    <?php else: ?>
                                        <option value="2">Prueba</option>
                                    <?php endif; ?>   
                                                                                                            
                                </select>
                            </div>

                            <div class="form-group">
                                <label>Estado</label>
                                
                                <select class="form-control" name="estado" id="estados">                                    
                                   
                                </select>
                            </div>

                            <div class="form-group">
                                <label>Municipios</label>
                                <select class="form-control" name="municipio" id="municipios">
                                    <option></option>

                                </select>
                            </div>

                            <div class="form-group">
                                <label>Sector</label>
                                <select class="form-control" name="sector" id="sector">
                                    <option></option>
                                    <?php if( $institucion->sector == 0 ): ?>
                                        <option selected value="0">Publico</option>
                                    <?php else: ?>
                                        <option value="0">Publico</option> 
                                    <?php endif; ?>

                                    <?php if( $institucion->sector == 1 ): ?>
                                        <option selected value="1">Privado</option>
                                    <?php else: ?>
                                        <option value="1">Privado</option>
                                    <?php endif; ?>
                                </select>
                            </div>
    
                        </div>

                    </div>
 
                    <button type="submit" class="btn btn-info">Guardar</button>

                <?php echo e(Form::close()); ?>


            </div>
        </div>
    </div>

<?php $__env->stopSection(); ?>

<?php $__env->startSection('JS'); ?>
    <?php echo e(Html::script('system/js/form.js')); ?>

    <script>

        var insiticion = <?php echo json_encode($institucion); ?>;
        console.log( "insiticion", insiticion );

        loadEstados();

        function loadEstados(){

            $("#estados").empty();
            $("#estados").append( "<option></option>" );
            $.ajax({
                url: '<?php echo e(route("estados")); ?>',
                type: "POST",
                data: {},
                error: function (e) {
                    console.log("Error",e);
                    if( e ){

                    }
                },      
                success: function (response) {                    
                    for( var estado of response.estados ){
                        if( estado.clave == insiticion.state ){
                            $("#estados").append( "<option selected value='"+estado.clave+"'>"+ estado.nombre +"</option>" );
                            loadMunicipios(estado.clave);
                        }else{
                            $("#estados").append( "<option value='"+estado.clave+"'>"+ estado.nombre +"</option>" );
                        }
                    }
                                
                }

            });   

        }
        

        $("#estados").change(function(){
            var valor = $( this ).val();            
            loadMunicipios(valor);

        });

        function loadMunicipios( id ){

            $("#municipios").empty();

            $.ajax({
                url: '<?php echo e(route("municipios")); ?>',
                type: "POST",
                data: { clave_estado: id },
                error: function (e) {
                    console.log("Error",e);
                    if( e ){

                    }
                },      
                success: function (response) {
                    console.log("municipios",response);

                    for( var municipio of response.municipios ){
                        console.log(municipio.nombre, insiticion.city);
                        if( municipio.id == insiticion.city ){
                            $("#municipios").append( "<option selected value='"+municipio.id+"'>"+ municipio.nombre +"</option>" );
                        }else{
                            $("#municipios").append( "<option value='"+municipio.clave+"'>"+ municipio.nombre +"</option>" );
                        }
                    }
                                
                }

            });   
        }        
        

    </script>
<?php $__env->stopSection(); ?>
<?php echo $__env->make('back.layout.dashboard', array_except(get_defined_vars(), array('__data', '__path')))->render(); ?>