@extends('back.layout.dashboard')

@section('contentTitle', 'Categorías')

@section('topButton')
    @if( $permitions["create"] )    
        <a href="{{ route('categoria_create') }}" class="m-l-15">
            <button type="button" class="btn btn-info d-none d-lg-block">
                <i class="fa fa-plus-circle"></i> Nueva Categoría
            </button>
        </a>
    @endif
@stop


{{-- Main Content --}}
@section('content_dashboard')
    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-body">
                    <div class="table-responsive">
                        <table id="table_principal" class="display nowrap table table-hover table-striped table-bordered" cellspacing="0" width="100%">
                            <thead>
                            <tr>
                                <th>ID</th>                                
                                <th>Nombre</th>                         
                                <th>Acciones</th>
                            </tr>
                            </thead>
                            <tbody>
                               @foreach ($categorias as $key => $categoria)
                                    <tr>
                                        <td>{{ $key + 1 }}</td>
                                        <td>{{ $categoria->nombre }}</td>                                                                                
                                        <td>
                                            @if( $permitions["edit"] )
                                                <a href="{{ route('editar_categoria', base64_encode($categoria->id)) }}">
                                                    <button type="button" class="btn btn-sm waves-effect waves-light btn-success"><i class="fas fa-edit"></i> Editar</button>
                                                </a>
                                            @endif

                                            @if( $permitions["delete"] )
                                                <a href="{{ route('delete_categoria', base64_encode($categoria->id)) }}" class="btn-delete">
                                                    <button type="button" class="btn btn-sm waves-effect waves-light btn-danger">
                                                        <i class="fas fa-minus-circle"></i> Eliminar
                                                    </button>
                                                </a>
                                            @endif
                                        </td>
                                    </tr>
                               @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
@stop

{{-- Page JS --}}
@section('JS')
    {{ Html::script('system/js/table.js')  }}
    {{ Html::script('system/js/form.js')  }}    
@stop
