@extends('back.layout.dashboard')

@section('CSS')
<link rel="stylesheet" href="{{ asset("assets/datetimepicker/jquery.datetimepicker.css") }}">

    <style>
        .btn-consultar{
            margin-top: 30px;
        }
    </style>

    {{-- CHARTS DE GOOGLE --}}
    <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
@endsection    

@section('contentTitle', 'Reporte por estatus')

@section('topButton')
    {{-- <a href="{{ route('instituciones') }}" class="m-l-15"><button type="button" class="btn btn-info d-none d-lg-block"><i class="fas fa-chevron-left"></i> Regresar</button></a> --}}
@stop

@section('content_dashboard')

    <div class="row">
        <div class="col-sm-12">
            <div class="card card-body">

                <form action="">
                    <div class="row">

                        @if ( $tipo )

                            <div class="form-group col-lg-2">
                                <label>Organizaciones</label>
                                <select class="form-control" name="" id="organizaciones">
                                    <option value="0">Todas</option>
                                    @foreach ($institucion as $item)
                                        <option value="{{ $item->id }}">{{ $item->name }}</option>
                                    @endforeach
                                </select>
                            </div>                                                    
                            
                        @endif

    
                        <div class="form-group col-lg-3">
                            <label>Estatus de incidencias</label>
                            <select class="form-control" name="" id="status">
                                <option value="0">Todos</option>
                                <option value="1">Abierto</option>
                                <option value="2">En seguimiento</option>
                                <option value="3">Cerrado</option>
                            </select>
                        </div>

                        <div class="form-group col-lg-2">
                            <label>Fecha inicio</label>
                            {{-- <input type="text" id="datepicker" autocomplete="off" name="fecha_inicio" class="form-control"> --}}
                            <input type="text" id="datetimepicker_format" class="input input-wide form-control fecha-inicial"/>
                        </div>

                        <div class="form-group col-lg-2">
                            <label>Fecha fin</label>
                            {{-- <input type="text" id="datepicker-2"name="fecha_fin" class="form-control"> --}}
                            <input type="text" id="datetimepicker_format_2" class="input input-wide form-control fecha-final"/>
                        </div>

                        <div class="col-lg-2">                                                        
                            <button type="button" class="btn btn-consultar btn-info" id="consultar">Consultar</button>
                        </div>

                    </div>
                </form>

                {{-- <div class="row">
                    
                    <ul class="nav nav-tabs mb-3" id="pills-tab" role="tablist">
                        <li class="nav-item">
                            <a class="nav-item nav-link active" id="#pie-li" data-toggle="pill" href="#pie" role="tab" aria-controls="pie" aria-selected="true">
                                <i class="fa fa-pie-chart" aria-hidden="true"></i>
                            </a>
                        </li>
                        <li class="nav-item">                            
                            <a class="nav-item nav-link tablas-footer" id="grap-li" data-toggle="pill" href="#grap" role="tab" aria-controls="vacaciones" aria-selected="false" onclick="graficas()">
                                <i class="fa fa-bar-chart" aria-hidden="true"></i>
                            </a>
                        </li>                    
                    </ul>

                </div>

                <div class="tab-content">
                    <div class="tab-pane fade show active" id="pie" role="tabpanel" aria-labelledby="puntaje-tab"> 
                        <div class="row">
                            <div class="col-lg-4"></div>
                            <div class="col-lg-4">                                
                                Abiertos( <strong style="color: #007bff;" id="head-abierto"></strong> )
                                Seguimiento( <strong style="color: #28a745;" id="head-seguimiento"></strong> )
                                Cerrados( <strong style="color: #dc3545 ;" id="head-cerrados"></strong> )                                
                            </div>
                        </div>
                        <div id="piechart" style="width: 100%; height: 600px;"></div>                                                        
                    </div>

                    <div class="tab-pane fade show" id="grap" role="tabpanel" aria-labelledby="puntaje-tab">                        
                        <div id="chart_div" style="width: 100%; height: 400px;"></div>
                    </div>
                </div> --}}

                <div id="chart_div" style="width: 100%; height: 400px;"></div>
                <div id="chart_div_2" style="display:none; width: 100%; height: 400px;"></div>

                <div class="row">
                    <div class="col-12">
                        <div class="table-responsive">
                            <h4>Registros</h4>

                            <table class="table table-striped table-bordered" id="table_principal">
                                <thead>
                                    <tr>
                                        <td>#</td>
                                        <td>Nombre</td>
                                        <td>Código</td>
                                        <td>Estatus</td>
                                        <td>Sector</td>
                                        <td>Fecha</td>
                                    </tr>
                                </thead>
                                <tbody id="registros">

                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>

@stop

@section('JS')
    {{ Html::script('system/js/form.js')  }}

    <script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>

    <script src="{{ asset("assets/datetimepicker/php-date-formatter.min.js") }}"></script>
    <script src="{{ asset("assets/datetimepicker/jquery.mousewheel.js") }}"></script>
    <script src="{{ asset("assets/datetimepicker/jquery.datetimepicker.js") }}"></script>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/lodash.js/4.17.15/lodash.min.js"></script>

    <script>

        var dataGrafica = [];
        var dataIncidentes = [];
        var chartsColumna = [];

        $('#datepicker').datepicker({
            uiLibrary: 'bootstrap'
        });

        $('#datepicker-2').datepicker({
            uiLibrary: 'bootstrap'
        });

        // google.charts.load('current', {'packages':['corechart']});
        // google.charts.setOnLoadCallback(drawChart);

        $.datetimepicker.setLocale('es');

        var date = new Date();

        $('#datetimepicker_format').datetimepicker({value:date, format: $("#datetimepicker_format_value").val()});
        $('#datetimepicker_format_2').datetimepicker({value:date, format: $("#datetimepicker_format_value").val()});  

        function grafica(){
            google.charts.load('current', {packages: ['corechart', 'bar']});
            google.charts.setOnLoadCallback(drawBasic);
        }


        function drawBasic() {

            // var data = new google.visualization.DataTable();
            // data.addColumn('timeofday', 'Días');
            // data.addColumn('number', 'Estatus');

            // data.addRows([
            //     [{v: [12, 0, 0], f: '2019-10-0'}, 1],
            //     [{v: [9, 0, 10], f: '2019-10-0'}, 2],
            //     [{v: [10, 0, 0], f:'10 am'}, 3],
            //     [{v: [11, 0, 0], f: '11 am'}, 4],
            //     [{v: [12, 0, 0], f: '12 pm'}, 5],
            //     [{v: [13, 0, 0], f: '1 pm'}, 6],
            //     [{v: [14, 0, 0], f: '2 pm'}, 7],
            //     [{v: [15, 0, 0], f: '3 pm'}, 8],
            //     [{v: [16, 0, 0], f: '4 pm'}, 9],
            //     [{v: [17, 0, 0], f: '5 pm'}, 10],
            // ]);

            var options = {
                title: 'Reporte por estatus diario',
                // hAxis: {
                //     title: 'Time of Day',
                //     format: 'h:mm a',
                // viewWindow: {
                //     min: [7, 30, 0],
                //     max: [17, 30, 0]
                // }
                // },
                // vAxis: {
                // title: 'Rating (scale of 1-10)'
                // }
            };

            console.log("data en grafica", dataGrafica);

            var data = google.visualization.arrayToDataTable(
                dataGrafica
                // ['Element', 'Density', { role: 'style' }],
                // ['Copper', 8.94, '#b87333'],            // RGB value
                // ['Silver', 10.49, 'silver'],            // English color name
                // ['Gold', 19.30, 'gold'],
                // ['Platinum', 21.45, 'color: #e5e4e2' ], // CSS-style declaration
            );

            var chart = new google.visualization.ColumnChart(
                document.getElementById('chart_div'));

            chart.draw(data, options);
        }
  

        $("#consultar").click(function(){
            var org     = $("#organizaciones").val();
            var estatus = $("#status").val();            
            var date_1  = $("#datetimepicker_format").val();
            var date_2  = $("#datetimepicker_format_2").val();

            console.log( org, estatus, date_1, date_2 );

            $.ajax({
                url: '{{ route("consulta_reporte_estatus") }}',
                type: "POST",
                data: { org, estatus, date_1, date_2 },
                error: function (jqXHR, status, error) {
                    
                    var content = "";
                    for( var res in jqXHR.responseJSON.errors ){
                        content = content + jqXHR.responseJSON.errors[res][0] + "<br>";                        
                        console.log("RES",content);
                    }

                    var form = document.createElement("div");
                    form.innerHTML = content;
                                            
                    swal({                       
                        text: "Error",
                        content: form,
                        icon: "error",                        
                    });                     
                },  
                success: function (response) {
                   
                    if( response.status ){
                        console.log(response);

                        $("#registros").empty();
                        $("#table_principal").DataTable().clear().destroy();

                        var num = 0;
                        for( var reg of response.incidentes ){
                            num++;
                            $("#registros").append("<tr><td>"+ num +"</td><td>"+ reg.name +"</td><td>"+ reg.codigo +"</td><td>"+ status( reg.estatus ) +"</td><td>"+ sector( reg.sector ) +"</td><td>"+reg.created_at+"</td></tr>");
                        }

                        setTimeout( function(){
                            $("#table_principal").DataTable();
                        },1000);
                        
                        addMesDia( response.incidentes, estatus );

                        // chart();
                        setTimeout(function(){
                            if( estatus == 0 ){
                                chartColumn();
                            }else{
                                grafica();
                            }
                        }, 500);

                        // addMesDia( response.incidentes );
                        // swal("Reportes!", response.message, "success");
                    }else{
                        swal("Reportes!", response.message, "error");
                    }
                }                         
            });

        });

        function status( status ){
            if( status == 1 ){
                return "Abierto";
            }else if( status == 2 ){
                return "Seguimiento";
            }else{
                return "Cerrado";
            }
        }

        function sector( sector ){
            if( sector == 0 ){
                return "Public";
            }else{
                return "Privado";
            }
        }
           

        function separador( texto ,separador, numArray ){
            return texto.split(separador)[numArray];
        }

        function addMesDia( data, status ){
         
            dataIncidentes=[];
            for( var reg of data ){
                // console.log(reg);
                var fecha = separador( reg.created_at, " ", 0 );

                dataIncidentes.push( { fecha: fecha, created_at: reg.created_at, estatus: reg.estatus, codigo:reg.codigo } );
            }

            // console.log(dataIncidentes);
            var group = _.groupBy(dataIncidentes, "fecha");

            if(status == 0){
                conteoGrficaDos(group);
            }else{
                conteoGrfica(group);
            }

            
        }

        function conteoGrficaDos( group ){
            chartsColumna = [];
            var  grafica = [];
            grafica.push(['Día', 'Abierto', 'Seguimiento', 'Cerrado']);
            for( var gpo in group ){
                grafica.push( [ gpo, sumaEstatus(group[gpo], 1), sumaEstatus(group[gpo], 2), sumaEstatus(group[gpo], 3)] );
                // console.log( "gpo", group[gpo], sumaEstatus(group[gpo], 1), sumaEstatus(group[gpo], 2), sumaEstatus(group[gpo], 3) );
            }

            chartsColumna = grafica;
            
        }

        function chartColumn(){

            google.charts.load('current', {'packages':['bar']});
            google.charts.setOnLoadCallback(drawChartColumn);
        }

        function conteoGrfica( group ){
            dataGrafica = [];
            var  grafica = [];
            grafica.push(['Element', 'Día', { role: 'style' }],);
            for( var gpo in group ){
                grafica.push( [ gpo, sumaEstatusDos( group[gpo] ), "#428bca" ] );
                console.log( "gpo", group[gpo], sumaEstatusDos(group[gpo], 1), sumaEstatusDos(group[gpo], 2), sumaEstatusDos(group[gpo], 3) );
            }

            dataGrafica = grafica;
            
        }

        function sumaEstatus( arr, status ){
            var num = 0;
            for( var estatus of arr ){
                if( estatus.estatus == status ){
                    num++;
                }                 
            }

            return num;
        }

        function sumaEstatusDos( arr ){
            var num = 0;
            for( var estatus of arr ){                                 
                num++;
            }

            return num;
        }

        function drawChartColumn() {

            console.log("chartsColumna", chartsColumna);

            var data = google.visualization.arrayToDataTable(          
            chartsColumna
            //   ['2014', 1000, 400, 200],
            //   ['2015', 1170, 460, 250],
            //   ['2016', 660, 1120, 300],
            //   ['2017', 1030, 540, 350]
            );

            var options = {
            chart: {
                title: 'Reporte por categorias',
                subtitle: 'Por día',
            },
            bars: 'vertical',
            vAxis: {format: 'decimal'},
            height: 400,
            colors: ['#007bff', '#28a745', '#dc3545']
            };

            var chart = new google.charts.Bar(document.getElementById('chart_div'));

            chart.draw(data, google.charts.Bar.convertOptions(options));

            // var btns = document.getElementById('btn-group');

            // btns.onclick = function (e) {

            //   if (e.target.tagName === 'BUTTON') {
            //     options.vAxis.format = e.target.id === 'none' ? '' : e.target.id;
            //     chart.draw(data, google.charts.Bar.convertOptions(options));
            //   }
            // }
        }

    </script>
@stop