@extends('back.layout.dashboard')

@section('contentTitle', 'Teléfonos de emergencia')

@section('topButton')
    @if( $permitions["create"] )    
        <a href="{{ route('nuevo_telefono') }}" class="m-l-15">
            <button type="button" class="btn btn-info d-none d-lg-block">
                <i class="fa fa-plus-circle"></i> Nuevo número de emergencia
            </button>
        </a>
    @endif
@stop

@section('CSS')
    {{-- <link href="https://unpkg.com/bootstrap-switch/dist/css/bootstrap3/bootstrap-switch.css" rel="stylesheet"> --}}
    {{-- CHARTS DE GOOGLE --}}
    <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
    <style>
        .panel-default{
            border-width: 1px;
            border-style: solid; 
            border-color: #eee;           
            border-radius: 10px;
            background-color: #F7F7F7;
        }

        .connectedSortable{
            margin-bottom: 12px;
        }

        .botones{
            padding-top: 30px;
        }

    </style>
@endsection


{{-- Main Content --}}
@section('content_dashboard')
    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-body" id="sortable1">
                    @foreach ($data as $telefono)
                        
                        <div class="panel panel-default connectedSortable" panel_id="{{ $telefono->id }}">
                            {{-- <div class="panel-heading">Panel Heading</div> --}}
                            <div class="panel-body">
                                <br>
                                <div class="row" style="padding-left: 10px;">
                                    <div class="col-lg-5 col-md-5">
                                        <div class="form-group">
                                            <label for="">Nombre</label>
                                            <input type="text" value="{{ $telefono->name }}" class="form-control" name="" id="name-{{$telefono->id}}">
                                        </div>                                    
                                    </div>
                                    <div class="col-lg-5 col-md-5">
                                        <div class="form-group">
                                            <label for="">Número de teléfono</label>
                                            <input type="text" value="{{ $telefono->telefono }}" class="form-control" name="" id="tel-{{$telefono->id}}">
                                        </div>                                    
                                    </div>
                                    <div class="col-lg-2 col-md-2 botones">
                                        {{-- onclick="editar( {{ $telefono }},{{ $telefono->id }} )" --}}
                                        <a class="btn btn-info" href="{{ route('editar_telefono', base64_encode($telefono->id)) }}"> Editar </a>
                                        <button class="btn btn-danger" onclick="eliminar( {{ $telefono }} )"> Eliminar </button>
                                        {{-- <div class="col-lg-12">
                                            <p>Estado</p>
                                            <div class="col-sm-6 col-lg-4">
                                                
                                                <p>
                                                    <input tel="{{$telefono->id}}" id="switch-{{ $telefono->id }}" type="checkbox" checked="checked" data-size="mini">
                                                </p>
                                            
                                            </div>
        
                                        </div> --}}
                                    </div>
                                </div>
                                {{-- <div class="row" style="padding-left: 10px;">
                                    <div class="col-lg-8">
                                        <div class="form-group">
                                            <label for="">URL</label>
                                            <input type="text" class="form-control" name="" id="">
                                        </div>  
                                    </div>
                                </div> --}}
                            </div>
                            {{-- <div class="panel-footer" style="padding: 10px">
                                <button class="btn btn-info" onclick="editar( {{ $telefono }} )"> Editar </button>
                                <button class="btn btn-danger" onclick="eliminar( {{ $telefono }} )"> Eliminar </button>
                            </div> --}}
                            
                        </div>
                        

                    @endforeach
                    
                </div>
                {{-- <button class="btn btn-success">Guardar</button> --}}
            </div>
        </div>
    </div>


    <div class="modal fade" tabindex="-1" role="dialog" id="editar-telefono">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Editar teléfono</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                
                

            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
              <button type="button" class="btn btn-info" id="btn-update-telefono">Guardar cambios</button>
            </div>
          </div><!-- /.modal-content -->
        </div><!-- /.modal-dialog -->
    </div><!-- /.modal -->
@stop

{{-- Page JS --}}
@section('JS')
    {{ Html::script('system/js/table.js')  }}
    {{ Html::script('system/js/form.js')  }}  

    <script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>
    
    {{-- <script src="{{ asset("assets/switch-bootstrap/js/highlight.js") }}"></script> --}}
    {{-- <script src="https://unpkg.com/bootstrap-switch@3.4.0/dist/js/bootstrap-switch.js"></script> --}}

    <script>

        var status = 0;
        var telefonos = {!! json_encode( $data ) !!};

        // load( telefonos );

        console.log(telefonos);    

        $("#sortable1").sortable({
            connectWith: ".connectedSortable",
            remove: function(event, ui) {
                ui.item.clone().appendTo('#sortable2');
                $(this).sortable('cancel');
            },
            stop: function( event, ui ){

                var orden = [];

                $("#sortable1 div.connectedSortable").each(function(index){
                    
                    var element = $(this).attr("panel_id"); // <-- en la variable element tienes tu elemento
                    console.log(index, element);
                    orden.push( { orden: index, id: element } );
                    // if (index ){ // ignorando el primer elemento cuando index es igual 0
                    // }

                });
                
                updateOrdenNumero( orden );
                console.log( orden );

            }
        }).disableSelection();

        // function load( telefonos ){

        //     if( telefonos.length == 0 ){
        //         return;
        //     }

        //     for( var telefono of telefonos ){
        //         console.log( telefono );
        //         $("#switch-"+telefono.id).bootstrapSwitch({                           
        //             size: "mini",
        //             animate: true,
        //             onColor: "primary",
        //             onText: "Activo",
        //             offText:"Inactivo",
        //             onSwitchChange: function (event, state) {
        //                 event.preventDefault();
        //                 if( status == 1 ){
        //                     var value = $(this).attr("tel");
        //                     activoInactivo(state, value);
        //                 }

        //                 return console.log(state, event.isDefaultPrevented())
        //             }
        //         }); 

        //         if( telefono.estatus ){
        //             $("#switch-"+telefono.id).bootstrapSwitch('state', 1);
        //         }else{
        //             $("#switch-"+telefono.id).bootstrapSwitch('state', 0);
        //         }

        //     }
        // }

        // function activoInactivo( state, event ){
        //     console.log("state", state, event);
        // }

        function editar( telefono, id ){
            
            var name     = $("#name-"+telefono.id).val();
            var telefono = $("#tel-"+telefono.id).val();                     
            
            // $.ajax({
            //     url: '{{ route("update_telefono_new") }}',
            //     type: "POST",
            //     data: { id: id, name:name, telefono:telefono },
            //     error: function (jqXHR, status, error) {
            //         var content = "";
            //         for( var res in jqXHR.responseJSON.errors ){
            //             content = content + jqXHR.responseJSON.errors[res][0] + "<br>";
            //             // console.log( jqXHR.responseJSON.errors[res] );
            //         }

            //         var form = document.createElement("div");
            //         form.innerHTML = content;
                    
            //         swal({                       
            //             text: "Error",
            //             content: form,
            //             icon: "warning",                        
            //         });
            //     },  
            //     success: function (response) {
            //         // table_principal
            //         if( response.status ){
            //             $("#name-"+telefono.id).val(name);
            //             $("#tel-"+telefono.id).val(telefono); 
            //             swal("Excelente!", response.message, "success");
            //             // loadVacaciones();
            //         }
            //         console.log(response);
                    
            //     }                         
            // });

        }

        function eliminar( telefono ){
            swal({
                    title: "Teléfono",
                    text: "¿Deseas eliminar el teléfono seleccionado?",
                    icon: "warning",          
                    buttons: ["No", "Sí, eliminar"],
                    showDenyButton: true,
                    showCancelButton: true,
                    dangerMode: true,
                })
                .then((result) => {
                    
                if (result) {

                    $.ajax({
                        url: '{{ route("eliminar_telefono_new") }}',
                        type: "POST",
                        data: { id:telefono.id },
                        error: function (e) {
                        
                        },  
                        success: function (response) {
                            // table_principal
                            if( response.status ){                                
                                swal("Excelente!", response.message, "success");
                                setTimeout(function(){
                                    location.reload();
                                },2000);
                                // loadVacaciones();
                            }
                            console.log(response);
                            
                        }                         
                    });

                } 
                // else {
                //     swal("Your imaginary file is safe!");
                // }
            });
        }

        function updateOrdenNumero( orden ){
            $.ajax({
                url: '{{ route("update_orden_telefono") }}',
                type: "POST",
                data: {orden:orden},
                error: function (e) {
                
                },  
                success: function (response) {
                    // table_principal
                    if( response.status ){
                        
                        swal("Excelente!", response.message, "success");
                        // loadVacaciones();
                    }
                    console.log(response);
                    
                }                         
            });
        }


        status = 1;

    </script>
@stop